tinsert(UISpecialFrames, "CT_RAMenuFrame");
CT_RA_BuffArray = {
	{ ["show"] = 1, ["name"] = "Power Word: Fortitude"},
	{ ["show"] = 1, ["name"] = "Prayer of Fortitude"},
	{ ["show"] = 1, ["name"] = "Mark of the Wild"},
	{ ["show"] = 1, ["name"] = "Gift of the Wild"},
	{ ["show"] = 1, ["name"] = "Arcane Intellect"},
	{ ["show"] = 1, ["name"] = "Admiral's Hat"},
	{ ["show"] = 1, ["name"] = "Shadow Protection"},
	{ ["show"] = 1, ["name"] = "Power Word: Shield"},
	{ ["show"] = 1, ["name"] = "Soulstone Resurrection"},
	{ ["show"] = 1, ["name"] = "Divine Spirit"},
	{ ["show"] = 1, ["name"] = "Thorns"},
	{ ["show"] = 1, ["name"] = "Fire Shield"},
	{ ["show"] = 1, ["name"] = "Fear Ward"},
	{ ["show"] = 1, ["name"] = "Blessing of Might"},
	{ ["show"] = 1, ["name"] = "Blessing of Wisdom"},
	{ ["show"] = 1, ["name"] = "Blessing of Kings"}
};

CT_RA_NotifyBuffs = { 
	[1] = 1,
	[2] = 1,
	[3] = 1,
	[4] = 1,
	[5] = 1,
	[6] = 1,
	[7] = 1,
	[8] = 1
};
CT_RA_NotifyDebuffs = { 
	[1] = 1,
	[2] = 1,
	[3] = 1,
	[4] = 1,
	[5] = 1,
	[6] = 1,
	[7] = 1,
	[8] = 1
};
CT_RA_MemberHeight = 40;
CT_RA_DefaultColor = {
	["r"] = 0,
	["g"] = 0.1,
	["b"] = 0.9,
	["a"] = 0.5
};
CT_RA_DefaultAlertColor = {
	["r"] = 1,
	["g"] = 1,
	["b"] = 1,
};
CT_RA_PercentColor = {
	["r"] = 1,
	["g"] = 1,
	["b"] = 1
};
CT_RA_ShowMTs = { 
	1, 1, 1, 1, 1
};
CT_RA_PartyFrame_IsShown = nil;
CT_RA_ClassHealings = {
	["Priest"] = {
		{ { "Heal", "Lesser Heal", "Greater Heal" }, "Lesser Heal, Heal and Greater Heal", 1 },
		{ "Flash Heal", "Flash Heal", 1 }
	},
	["Shaman"] = {
		{ "Healing Wave", "Healing Wave", 1 },
		{ "Lesser Healing Wave", "Lesser Healing Wave", 1 }
	},
	["Druid"] = {
		{ "Healing Touch", "Healing Touch", 1 },
		{ "Regrowth", "Regrowth", 1 }
	},
	["Paladin"] = {
		{ "Holy Light", "Holy Light", 1 },
		{ "Flash of Light", "Flash of Light", 1 }
	}
};

function CT_RAMenu_OnLoad()
	CT_RAMenuFrameHomeButton1Text:SetText("General Options");
	CT_RAMenuFrameHomeButton2Text:SetText("Buff Options");
	CT_RAMenuFrameHomeButton3Text:SetText("Misc Options");
	CT_RAMenuFrameHomeButton4Text:SetText("Additional Options");
	CT_RAMenuFrameHomeButton5Text:SetText("Frequently Asked Questions");

	CT_RAMenuFrameHomeButton1Description:SetText("Change general stuff, such as whether to show mana bars, etc etc.");
	CT_RAMenuFrameHomeButton2Description:SetText("Change the way Buffs and Debuffs are displayed.");
	CT_RAMenuFrameHomeButton3Description:SetText("Things that do not fit in other categories go here.");
	CT_RAMenuFrameHomeButton4Description:SetText("Regulating message spam, scaling of windows, etc.");
	CT_RAMenuFrameHomeButton5Description:SetText("Have problems using the mod? Look here!");
end

function CT_RAMenu_OnShow()
	CT_RAMenu_ShowHome();
	this:SetScale(0.8);
	CT_RAMenuFrameHomeButton1:SetScale(0.73);
	CT_RAMenuFrameHomeButton2:SetScale(0.73);
	CT_RAMenuFrameHomeButton3:SetScale(0.73);
	CT_RAMenuFrameHomeButton4:SetScale(0.73);
	CT_RAMenuFrameHomeButton5:SetScale(0.73);
end

function CT_RAMenuButton_OnClick()
	CT_RAMenuFrameHome:Hide();
	if ( this:GetID() == 1 ) then
		CT_RAMenuFrameGeneral:Show();
	elseif ( this:GetID() == 2 ) then
		CT_RAMenuFrameBuffs:Show();
	elseif ( this:GetID() == 3 ) then
		CT_RAMenuFrameMisc:Show();
	elseif ( this:GetID() == 4 ) then
		CT_RAMenuFrameAdditional:Show();
	elseif ( this:GetID() == 5 ) then
		CT_RAMenuFrameSort:Show();
	end
end

function CT_RAMenu_ShowHome()
	CT_RAMenuFrameHome:Show();
	CT_RAMenuFrameGeneral:Hide();
	CT_RAMenuFrameBuffs:Hide();
	CT_RAMenuFrameSort:Hide();
	CT_RAMenuFrameMisc:Hide();
	CT_RAMenuFrameAdditional:Hide();
end

function CT_RAMenuBuffs_OnEvent()
	if ( event == "VARIABLES_LOADED" ) then
		local found;
		for k, v in CT_RA_BuffArray do
			if ( v["name"] == "Fear Ward" ) then
				found = 1;
				break;
			end
		end
		if ( not found ) then
			tinsert(CT_RA_BuffArray, { ["show"] = 1, ["name"] = "Fear Ward" });
		end
		local i = 1;
		for i = 1, 6, 1 do
			getglobal("CT_RAMenuFrameBuffsDebuff" .. i .. "Text"):SetText(string.gsub(CT_RA_DebuffColors[i]["type"], "_", " "));

			local val = CT_RA_DebuffColors[i];
			getglobal("CT_RAMenuFrameBuffsDebuff" .. i .. "SwatchNormalTexture"):SetVertexColor(val.r, val.g, val.b);

			if ( val["id"] ~= -1 ) then
				getglobal("CT_RAMenuFrameBuffsDebuff" .. i .. "CheckButton"):SetChecked(1);
			else
				getglobal("CT_RAMenuFrameBuffsDebuff" .. i .. "Text"):SetTextColor(0.3, 0.3, 0.3);
			end

		end
		for key, val in CT_RA_BuffArray do
			if ( val["show"] ~= -1 ) then
				getglobal("CT_RAMenuFrameBuffsBuff" .. key .. "CheckButton"):SetChecked(1);
			else
				getglobal("CT_RAMenuFrameBuffsBuff" .. key .. "Text"):SetTextColor(0.3, 0.3, 0.3);
			end
			getglobal("CT_RAMenuFrameBuffsBuff" .. key .. "Text"):SetText(val["name"]);
		end
		CT_RAMenuFrameBuffsNotify:SetChecked(CT_RA_NotifyDebuffs);

		for i = 1, 8, 1 do
			getglobal("CT_RAMenuFrameBuffsNotifyGroup" .. i .. "Text"):SetText("Group " .. i);
			getglobal("CT_RAMenuFrameBuffsNotifyDebuffsGroup" .. i .. "Text"):SetText("Group " .. i);
			if ( not CT_RA_NotifyBuffs["main"] ) then
				getglobal("CT_RAMenuFrameBuffsNotifyGroup" .. i .. "Text"):SetTextColor(0.3, 0.3, 0.3);
				getglobal("CT_RAMenuFrameBuffsNotifyGroup" .. i .. "Text"):SetTextColor(0.3, 0.3, 0.3);
				getglobal("CT_RAMenuFrameBuffsNotifyGroup" .. i .. "CheckButton"):Disable();
			else
				getglobal("CT_RAMenuFrameBuffsNotifyBuffs"):SetChecked(1);
			end
			if ( CT_RA_NotifyBuffs[i] ) then
				getglobal("CT_RAMenuFrameBuffsNotifyGroup" .. i .. "CheckButton"):SetChecked(1);
			end
			if ( not CT_RA_NotifyDebuffs or not CT_RA_NotifyDebuffs["main"] ) then
				getglobal("CT_RAMenuFrameBuffsNotifyDebuffsGroup" .. i .. "Text"):SetTextColor(0.3, 0.3, 0.3);
				getglobal("CT_RAMenuFrameBuffsNotifyDebuffsGroup" .. i .. "Text"):SetTextColor(0.3, 0.3, 0.3);
				getglobal("CT_RAMenuFrameBuffsNotifyDebuffsGroup" .. i .. "CheckButton"):Disable();
			else
				getglobal("CT_RAMenuFrameBuffsNotify"):SetChecked(1);
			end
			if ( CT_RA_NotifyBuffs[i] ) then
				getglobal("CT_RAMenuFrameBuffsNotifyGroup" .. i .. "CheckButton"):SetChecked(1);
			end
			if ( CT_RA_NotifyDebuffs[i] ) then
				getglobal("CT_RAMenuFrameBuffsNotifyDebuffsGroup" .. i .. "CheckButton"):SetChecked(1);
			end
		end
		if ( CT_RA_MemberHeight == 36 ) then
			CT_RAMenuFrameGeneralDisplayShowMPCB:SetChecked(nil);
		elseif ( CT_RA_MemberHeight == 32 ) then
			CT_RAMenuFrameGeneralDisplayShowHealthCB:SetChecked(nil);
		elseif ( CT_RA_MemberHeight == 28 ) then
			CT_RAMenuFrameGeneralDisplayShowHealthCB:SetChecked(nil);
			CT_RAMenuFrameGeneralDisplayShowMPCB:SetChecked(nil);
		end

		if ( CT_RA_HideNames ) then
			CT_RAMenuFrameGeneralDisplayShowGroupsCB:SetChecked(nil);
		end
		if ( CT_RA_LockGroups ) then
			CT_RAMenuFrameGeneralDisplayLockGroupsCB:SetChecked(1);
		end
		CT_RAMenuFrameGeneralDisplayWindowColorSwatchNormalTexture:SetVertexColor(CT_RA_DefaultColor.r, CT_RA_DefaultColor.g, CT_RA_DefaultColor.b);
		CT_RAMenuFrameGeneralDisplayAlertColorSwatchNormalTexture:SetVertexColor(CT_RA_DefaultAlertColor.r, CT_RA_DefaultAlertColor.g, CT_RA_DefaultAlertColor.b);

		if ( CT_RA_ShowHP ) then
			CT_RAMenuFrameGeneralDisplayShowHPCB:SetChecked(1);
			if ( CT_RA_ShowHP == 2 ) then
				CT_RAMenuFrameGeneralDisplayShowHPPercentCB:SetChecked(1);
			end
			CT_RAMenuFrameGeneralDisplayShowHPSwatchNormalTexture:SetVertexColor(CT_RA_PercentColor.r, CT_RA_PercentColor.g, CT_RA_PercentColor.b);
			CT_RAMenuFrameGeneralDisplayShowHPSwatchBG:SetVertexColor(1, 1, 1);
		else
			CT_RAMenuFrameGeneralDisplayShowHPPercentCB:Disable();
			CT_RAMenuFrameGeneralDisplayHealthPercentsText:SetTextColor(0.3, 0.3, 0.3);
			CT_RAMenuFrameGeneralDisplayShowHPSwatchNormalTexture:SetVertexColor(0.3, 0.3, 0.3);
			CT_RAMenuFrameGeneralDisplayShowHPSwatchBG:SetVertexColor(0.3, 0.3, 0.3);
		end
		CT_RA_UpdateRaidGroupColors();
		CT_RA_UpdateRaidMovability();

		for i = 1, 5, 1 do
			getglobal("CT_RAMenuFrameGeneralTargetsTarget" .. i .. "CB"):SetChecked(CT_RA_ShowMTs[i]);
		end
		CT_RAMenu_CheckParty();
		if ( CT_RA_SORTTYPE == "class" ) then
			UIDropDownMenu_SetSelectedID(CT_RAMenuFrameGeneralMiscDropDown, 2);
		elseif ( CT_RA_SORTTYPE == "custom" ) then
			UIDropDownMenu_SetSelectedID(CT_RAMenuFrameGeneralMiscDropDown, 3);
		end
		
		local num = 0;
		if ( CT_RA_ShowGroups ) then
			for k, v in CT_RA_ShowGroups do
				num = num + 1;
				getglobal("CT_RAOptionsGroupCB" .. k):SetChecked(1);
			end
			if ( num > 0 ) then
				CT_RACheckAllGroups:SetChecked(1);
			else
				CT_RACheckAllGroups:SetChecked(nil);
			end
		end
		if ( CT_RA_HideOffline ) then
			CT_RAMenuFrameGeneralMiscHideOfflineCB:SetChecked(1);
		end
		if ( CT_RA_HideNA ) then
			CT_RAMenuFrameGeneralMiscHideNACB:SetChecked(1);
		end
		if ( CT_RA_HideShort ) then
			CT_RAMenuFrameGeneralMiscHideShortCB:SetChecked(1);
		end
		if ( CT_RA_ShowDebuffs ) then
			CT_RAMenuFrameBuffsShowDebuffsCheckButton:SetChecked(1);
		end
		if ( CT_RA_HideBorder ) then
			CT_RAMenuFrameGeneralMiscBorderCB:SetChecked(1);
		end
		if ( CT_RA_HideParty ) then
			CT_RAMenuFrameGeneralMiscHidePartyCB:SetChecked(1);
		end
		if ( CT_RA_WindowScaling ) then
			CT_RAMenuGlobalFrame.scaleupdate = 0.1;
		end
		CT_RAMenuMisc_Update();
		CT_RA_UpdateRaidGroup();
	elseif ( event == "RAID_ROSTER_UPDATE" or event == "PARTY_MEMBERS_CHANGED" ) then
		CT_RAMenu_CheckParty();
	end
end

function CT_RAMenu_CheckParty()
	if (  CT_RA_HideParty and GetNumRaidMembers() > 0 ) then
		CT_RA_PartyFrame_IsShown = PARTY_FRAME_SHOWN;
		HidePartyFrame();
	else
		if ( ( not CT_RA_PartyFrame_IsShown and PARTY_FRAME_SHOWN == 1 ) or CT_RA_PartyFrame_IsShown == 1 ) then
			CT_RA_PartyFrame_IsShown = nil;
			ShowPartyFrame();
		end
	end
	if ( CT_CheckLSidebar ) then
		CT_CheckLSidebar();
	end
end

CT_oldShowPartyFrame = ShowPartyFrame;
function CT_newShowPartyFrame()
	CT_oldShowPartyFrame();
	if ( CT_RA_PartyFrame_IsShown ) then
		CT_RAMenu_CheckParty();
	end
end
ShowPartyFrame = CT_newShowPartyFrame;

function CT_RAMenuNotify_SetChecked()
	local var, frame;
	if ( this == CT_RAMenuFrameBuffsNotify ) then
		CT_RA_NotifyDebuffs["main"] = this:GetChecked();
		frame = "CT_RAMenuFrameBuffsNotifyDebuffsGroup";
	else
		CT_RA_NotifyBuffs["main"] = this:GetChecked();
		frame = "CT_RAMenuFrameBuffsNotifyGroup";
	end
	for i = 1, 8, 1 do
		getglobal(frame .. i .. "Text"):SetText("Group " .. i);
		if ( not this:GetChecked() ) then
			getglobal(frame .. i .. "Text"):SetTextColor(0.3, 0.3, 0.3);
			getglobal(frame .. i .. "CheckButton"):Disable();
		else
			getglobal(frame .. i .. "Text"):SetTextColor(1, 1, 1);
			getglobal(frame .. i .. "CheckButton"):Enable();
		end
	end
end

function CT_RAMenuNotifyGroup_SetChecked()
	if ( string.find(this:GetParent():GetName(), "Debuffs") ) then -- Lazy way, I know :)
		CT_RA_NotifyDebuffs[this:GetParent():GetID()] = this:GetChecked();
	else
		CT_RA_NotifyBuffs[this:GetParent():GetID()] = this:GetChecked();
	end
end

function CT_RAMenuDebuff_OnClick()
	local frame = this:GetParent();
	local type = getglobal(this:GetParent():GetName() .. "Text"):GetText();
	type = gsub(type, " ", "");
	frame.r = CT_RA_DebuffColors[frame:GetID()]["r"];
	frame.g = CT_RA_DebuffColors[frame:GetID()]["g"];
	frame.b = CT_RA_DebuffColors[frame:GetID()]["b"];
	frame.opacity = CT_RA_DebuffColors[frame:GetID()]["a"];
	frame.opacityFunc = CT_RAMenuDebuff_SetColor;
	frame.swatchFunc = CT_RAMenuDebuff_SetOpacity;
	frame.hasOpacity = 1;
	ColorPickerFrame.frame = frame;
	CloseMenus();
	UIDropDownMenuButton_OpenColorPicker(frame);
end

function CT_RAMenuDebuff_SetColor()
	local type = getglobal(ColorPickerFrame.frame:GetName() .. "Text"):GetText();
	local r, g, b = ColorPickerFrame:GetColorRGB();
	CT_RA_DebuffColors[ColorPickerFrame.frame:GetID()]["r"] = r;
	CT_RA_DebuffColors[ColorPickerFrame.frame:GetID()]["g"] = g;
	CT_RA_DebuffColors[ColorPickerFrame.frame:GetID()]["b"] = b;
	getglobal(ColorPickerFrame.frame:GetName() .. "SwatchNormalTexture"):SetVertexColor(r, g, b);
end

function CT_RAMenuDebuff_SetOpacity()
	local type = getglobal(ColorPickerFrame.frame:GetName() .. "Text"):GetText();
	local a = OpacitySliderFrame:GetValue();
	CT_RA_DebuffColors[ColorPickerFrame.frame:GetID()]["a"] = a;
end

function CT_RAMenuBuff_MoveUp()
	if ( this:GetParent():GetID() == 1 ) then
		return;
	end

	if ( string.find(this:GetParent():GetName(), "Debuff") ) then
		-- Debuff
		local temp = getglobal("CT_RAMenuFrameBuffsDebuff" .. (this:GetParent():GetID()-1) .. "Text"):GetText();
		local temp2 = getglobal(this:GetParent():GetName() .. "Text"):GetText();
		getglobal("CT_RAMenuFrameBuffsDebuff" .. (this:GetParent():GetID()-1) .. "Text"):SetText(temp2);
		getglobal(this:GetParent():GetName() .. "Text"):SetText(temp);

		local temparr = CT_RA_DebuffColors[this:GetParent():GetID()];
		local temparr2 = CT_RA_DebuffColors[this:GetParent():GetID()-1];
		CT_RA_DebuffColors[this:GetParent():GetID()] = temparr2;
		CT_RA_DebuffColors[this:GetParent():GetID()-1] = temparr;

		getglobal("CT_RAMenuFrameBuffsDebuff" .. this:GetParent():GetID()-1 .. "SwatchNormalTexture"):SetVertexColor(temparr.r, temparr.g, temparr.b);
		getglobal("CT_RAMenuFrameBuffsDebuff" .. this:GetParent():GetID() .. "SwatchNormalTexture"):SetVertexColor(temparr2.r, temparr2.g, temparr2.b);

		if ( temparr2["id"] ~= -1 ) then
			getglobal(this:GetParent():GetName() .. "CheckButton"):SetChecked(1);
		else
			getglobal(this:GetParent():GetName() .. "CheckButton"):SetChecked(nil);
		end
		if ( temparr["id"] ~= -1 ) then
			getglobal("CT_RAMenuFrameBuffsDebuff" .. (this:GetParent():GetID()-1) .. "CheckButton"):SetChecked(1);
		else
			getglobal("CT_RAMenuFrameBuffsDebuff" .. (this:GetParent():GetID()-1) .. "CheckButton"):SetChecked(nil);
		end

	else
		-- Buff
		local temp = getglobal("CT_RAMenuFrameBuffsBuff" .. (this:GetParent():GetID()-1) .. "Text"):GetText();
		local temp2 = getglobal(this:GetParent():GetName() .. "Text"):GetText();
		getglobal("CT_RAMenuFrameBuffsBuff" .. (this:GetParent():GetID()-1) .. "Text"):SetText(temp2);
		getglobal(this:GetParent():GetName() .. "Text"):SetText(temp);

		local temparr = CT_RA_BuffArray[this:GetParent():GetID()];
		local temparr2 = CT_RA_BuffArray[this:GetParent():GetID()-1];
		CT_RA_BuffArray[this:GetParent():GetID()] = temparr2;
		CT_RA_BuffArray[this:GetParent():GetID()-1] = temparr;
		if ( temparr2["show"] ~= -1 ) then
			getglobal(this:GetParent():GetName() .. "CheckButton"):SetChecked(1);
		else
			getglobal(this:GetParent():GetName() .. "CheckButton"):SetChecked(nil);
		end
		if ( temparr["show"] ~= -1 ) then
			getglobal("CT_RAMenuFrameBuffsBuff" .. (this:GetParent():GetID()-1) .. "CheckButton"):SetChecked(1);
		else
			getglobal("CT_RAMenuFrameBuffsBuff" .. (this:GetParent():GetID()-1) .. "CheckButton"):SetChecked(nil);
		end
	end
	CT_RA_UpdateRaidGroup();
end
	
	
function CT_RAMenuBuff_MoveDown()

	if ( string.find(this:GetParent():GetName(), "Debuff") ) then
		if ( not getglobal("CT_RAMenuFrameBuffsDebuff" .. (this:GetParent():GetID()+1) .. "Text") ) then return; end
		-- Debuff
		local temp = getglobal("CT_RAMenuFrameBuffsDebuff" .. (this:GetParent():GetID()+1) .. "Text"):GetText();
		local temp2 = getglobal(this:GetParent():GetName() .. "Text"):GetText();
		getglobal("CT_RAMenuFrameBuffsDebuff" .. (this:GetParent():GetID()+1) .. "Text"):SetText(temp2);
		getglobal(this:GetParent():GetName() .. "Text"):SetText(temp);

		local temparr = CT_RA_DebuffColors[this:GetParent():GetID()];
		local temparr2 = CT_RA_DebuffColors[this:GetParent():GetID()+1];
		CT_RA_DebuffColors[this:GetParent():GetID()] = temparr2;
		CT_RA_DebuffColors[this:GetParent():GetID()+1] = temparr;

		getglobal("CT_RAMenuFrameBuffsDebuff" .. this:GetParent():GetID()+1 .. "SwatchNormalTexture"):SetVertexColor(temparr.r, temparr.g, temparr.b);
		getglobal("CT_RAMenuFrameBuffsDebuff" .. this:GetParent():GetID() .. "SwatchNormalTexture"):SetVertexColor(temparr2.r, temparr2.g, temparr2.b);

		if ( temparr2["id"] ~= -1 ) then
			getglobal(this:GetParent():GetName() .. "CheckButton"):SetChecked(1);
		else
			getglobal(this:GetParent():GetName() .. "CheckButton"):SetChecked(nil);
		end
		if ( temparr["id"] ~= -1 ) then
			getglobal("CT_RAMenuFrameBuffsDebuff" .. (this:GetParent():GetID()+1) .. "CheckButton"):SetChecked(1);
		else
			getglobal("CT_RAMenuFrameBuffsDebuff" .. (this:GetParent():GetID()+1) .. "CheckButton"):SetChecked(nil);
		end

	else
		if ( not getglobal("CT_RAMenuFrameBuffsBuff" .. (this:GetParent():GetID()+1) .. "Text") ) then return; end
		-- Buff
		local temp = getglobal("CT_RAMenuFrameBuffsBuff" .. (this:GetParent():GetID()+1) .. "Text"):GetText();
		local temp2 = getglobal(this:GetParent():GetName() .. "Text"):GetText();
		getglobal("CT_RAMenuFrameBuffsBuff" .. (this:GetParent():GetID()+1) .. "Text"):SetText(temp2);
		getglobal(this:GetParent():GetName() .. "Text"):SetText(temp);

		local temparr = CT_RA_BuffArray[this:GetParent():GetID()];
		local temparr2 = CT_RA_BuffArray[this:GetParent():GetID()+1];
		CT_RA_BuffArray[this:GetParent():GetID()] = temparr2;
		CT_RA_BuffArray[this:GetParent():GetID()+1] = temparr;

		if ( temparr2["show"] ~= -1 ) then
			getglobal(this:GetParent():GetName() .. "CheckButton"):SetChecked(1);
		else
			getglobal(this:GetParent():GetName() .. "CheckButton"):SetChecked(nil);
		end
		if ( temparr["show"] ~= -1 ) then
			getglobal("CT_RAMenuFrameBuffsBuff" .. (this:GetParent():GetID()+1) .. "CheckButton"):SetChecked(1);
		else
			getglobal("CT_RAMenuFrameBuffsBuff" .. (this:GetParent():GetID()+1) .. "CheckButton"):SetChecked(nil);
		end
	end
	CT_RA_UpdateRaidGroup();
end
	
function CT_RAMenuBuff_ShowToggle()
	local newid;
	if ( this:GetChecked() ) then
		newid = this:GetParent():GetID();
		getglobal(this:GetParent():GetName() .. "Text"):SetTextColor(1, 1, 1);
	else
		getglobal(this:GetParent():GetName() .. "Text"):SetTextColor(0.3, 0.3, 0.3);
		newid = -1;
	end
	local type = getglobal(this:GetParent():GetName() .. "Text"):GetText();
	if ( string.find(this:GetParent():GetName(), "Debuff") ) then
		-- Debuff
		CT_RA_DebuffColors[this:GetParent():GetID()].id = newid;
	else
		-- Buff
		if ( this:GetChecked() ) then
			CT_RA_BuffArray[this:GetParent():GetID()]["show"] = 1;
		else
			CT_RA_BuffArray[this:GetParent():GetID()]["show"] = -1;
		end
	end
	CT_RA_UpdateRaidGroup();
end


function CT_RAMenu_General_JoinChannel()
	if ( CT_RA_Channel ) then
		local name = CT_RA_Channel;
		local zoneChannel, channelName = JoinChannelByName(name, nil, DEFAULT_CHAT_FRAME:GetID());
		if ( channelName ) then
			name = channelName;
		end
		if ( not zoneChannel ) then
			return;
		end
		
		local i = 1;

		while ( DEFAULT_CHAT_FRAME.channelList[i] ) do
			i = i + 1;
		end
		DEFAULT_CHAT_FRAME.channelList[i] = name;
		DEFAULT_CHAT_FRAME.zoneChannelList[i] = zoneChannel;
	end
end

function CT_RAMenu_General_EditChannel()
	if ( not this.editing ) then
		this.editing = 1;
		this:SetText("Set Channel");
		getglobal(this:GetParent():GetName() .. "ChannelEB"):Show();
		if ( CT_RA_Channel ) then
			getglobal(this:GetParent():GetName() .. "ChannelEB"):SetText(CT_RA_Channel);
			getglobal(this:GetParent():GetName() .. "ChannelEB"):HighlightText();
		else
			getglobal(this:GetParent():GetName() .. "ChannelEB"):SetText("");
		end
		getglobal(this:GetParent():GetName() .. "ChannelNameText"):Hide();
		getglobal(this:GetParent():GetName() .. "JoinChannel"):Disable();
		getglobal(this:GetParent():GetName() .. "BroadcastChannel"):Disable();
	else
		this:SetText("Edit Channel");
		getglobal(this:GetParent():GetName() .. "JoinChannel"):Enable();
		getglobal(this:GetParent():GetName() .. "BroadcastChannel"):Enable();
		this.editing = nil;

		local name = getglobal(this:GetParent():GetName() .. "ChannelEB"):GetText();
		if ( strsub(name, strlen(name)) == " " ) then
			name = strsub(name, 1, strlen(name)-1);
		end
		getglobal(this:GetParent():GetName() .. "ChannelEB"):Hide();
		if ( strlen(name) > 0 ) then
			CT_RA_Channel = name;
			getglobal(this:GetParent():GetName() .. "ChannelNameText"):SetText(name);
		else
			getglobal(this:GetParent():GetName() .. "ChannelNameText"):SetText("<No Channel>");
			CT_RA_Channel = nil;
		end
		getglobal(this:GetParent():GetName() .. "ChannelNameText"):Show();
	end
end

function CT_RAMenu_General_ChannelOnShow()
	if ( CT_RA_Channel ) then
		getglobal(this:GetName() .. "ChannelNameText"):SetText(CT_RA_Channel);
	else
		getglobal(this:GetName() .. "ChannelNameText"):SetText("<No Channel>");
	end
	local edit = getglobal(this:GetName() .. "EditChannel");
	getglobal(this:GetName() .. "JoinChannel"):Enable();
	getglobal(this:GetName() .. "BroadcastChannel"):Enable();
	edit:SetText("Edit Channel");
	edit.editing = nil;
	getglobal(this:GetName() .. "ChannelEB"):Hide();
	getglobal(this:GetName() .. "ChannelNameText"):Show();
end

function CT_RAMenu_General_BroadcastChannel()
	if ( not CT_RA_Channel or CT_RA_Level < 1 ) then return; end
	SendChatMessage("<CTMod> This is an automatic message sent by CT_RaidAssist. Channel changed to: " .. CT_RA_Channel, "RAID");
end

function CT_RAMenuDisplay_ShowMP()
	if ( this:GetChecked() ) then
		CT_RA_MemberHeight = CT_RA_MemberHeight+4;
	else
		CT_RA_MemberHeight = CT_RA_MemberHeight-4;
	end
	CT_RA_UpdateRaidGroup();
	CT_RA_UpdateMTs();
end

function CT_RAMenuDisplay_ShowHealth()
	if ( this:GetChecked() ) then
		CT_RA_MemberHeight = CT_RA_MemberHeight+8;
	else
		CT_RA_MemberHeight = CT_RA_MemberHeight-8;
	end
	CT_RA_UpdateRaidGroup();
	CT_RA_UpdateMTs();
end

function CT_RAMenuDisplay_ShowHP()
	if ( this:GetChecked() ) then
		if ( CT_RAMenuFrameGeneralDisplayShowHPPercentCB:GetChecked() ) then
			CT_RA_ShowHP = 2;
		else
			CT_RA_ShowHP = 1;
		end
	else
		CT_RA_ShowHP = nil;
	end
	if ( this:GetChecked() ) then
		CT_RAMenuFrameGeneralDisplayHealthPercentsText:SetTextColor(1, 1, 1);
		CT_RAMenuFrameGeneralDisplayShowHPPercentCB:Enable();
		CT_RAMenuFrameGeneralDisplayShowHPSwatchNormalTexture:SetVertexColor(CT_RA_PercentColor.r, CT_RA_PercentColor.g, CT_RA_PercentColor.b);
		CT_RAMenuFrameGeneralDisplayShowHPSwatchBG:SetVertexColor(1, 1, 1);
	else
		CT_RAMenuFrameGeneralDisplayHealthPercentsText:SetTextColor(0.3, 0.3, 0.3);
		CT_RAMenuFrameGeneralDisplayShowHPPercentCB:Disable();
		CT_RAMenuFrameGeneralDisplayShowHPSwatchNormalTexture:SetVertexColor(0.3, 0.3, 0.3);
		CT_RAMenuFrameGeneralDisplayShowHPSwatchBG:SetVertexColor(0.3, 0.3, 0.3);
	end
	CT_RA_UpdateRaidGroup();
	CT_RA_UpdateMTs();
end

function CT_RAMenuDisplay_ShowHPPercents()
	if ( this:GetChecked() ) then
		CT_RA_ShowHP = 2;
	else
		CT_RA_ShowHP = 1;
	end
	CT_RA_UpdateRaidGroup();
end

function CT_RAMenuDisplay_ShowGroupNames()
	CT_RA_HideNames = not this:GetChecked();
	CT_RA_UpdateRaidGroup();
end

function CT_RAMenuDisplay_ChangeWC()
	local frame = this:GetParent();
	frame.r = CT_RA_DefaultColor["r"];
	frame.g = CT_RA_DefaultColor["g"];
	frame.b = CT_RA_DefaultColor["b"];
	frame.opacity = CT_RA_DefaultColor["a"];
	frame.opacityFunc = CT_RAMenuDisplay_SetOpacity;
	frame.swatchFunc = CT_RAMenuDisplay_SetColor;
	frame.cancelFunc = CT_RAMenuDisplay_CancelColor;
	frame.hasOpacity = 1;
	CloseMenus();
	UIDropDownMenuButton_OpenColorPicker(frame);
end

function CT_RAMenuDisplay_SetColor()
	local r, g, b = ColorPickerFrame:GetColorRGB();
	CT_RA_DefaultColor["r"] = r;
	CT_RA_DefaultColor["g"] = g;
	CT_RA_DefaultColor["b"] = b;
	CT_RAMenuFrameGeneralDisplayWindowColorSwatchNormalTexture:SetVertexColor(r, g, b);
	CT_RA_UpdateRaidGroupColors();
end

function CT_RAMenuDisplay_SetOpacity()
	CT_RA_DefaultColor["a"] = OpacitySliderFrame:GetValue();
	CT_RA_UpdateRaidGroupColors();
end

function CT_RAMenuDisplay_CancelColor(val)
	CT_RA_DefaultColor["r"] = val.r;
	CT_RA_DefaultColor["g"] = val.g;
	CT_RA_DefaultColor["b"] = val.b;
	CT_RA_DefaultColor["a"] = val.opacity;
	CT_RAMenuFrameGeneralDisplayWindowColorSwatchNormalTexture:SetVertexColor(val.r, val.g, val.b);
	CT_RA_UpdateRaidGroupColors();
end

function CT_RAMenuDisplay_LockGroups()
	CT_RA_LockGroups = this:GetChecked();
	CT_RA_UpdateRaidMovability();
end

function CT_RAMenuTarget_Toggle()
	CT_RA_ShowMTs[this:GetID()] = this:GetChecked();
	CT_RA_UpdateMTs();
end

function CT_RAMenuFrameGeneralMiscDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, CT_RAMenuFrameGeneralMiscDropDown_Initialize);
	UIDropDownMenu_SetWidth(130);
	UIDropDownMenu_SetSelectedID(CT_RAMenuFrameGeneralMiscDropDown, 1);
end

function CT_RAMenuFrameGeneralMiscDropDown_Initialize()
	local info = {};
	info.text = "Group";
	info.func = CT_RAMenuFrameGeneralMiscDropDown_OnClick;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = "Class";
	info.func = CT_RAMenuFrameGeneralMiscDropDown_OnClick;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = "Custom";
	info.func = CT_RAMenuFrameGeneralMiscDropDown_OnClick;
	UIDropDownMenu_AddButton(info);
end


function CT_RAMenuFrameGeneralMiscDropDown_OnClick()
	UIDropDownMenu_SetSelectedID(CT_RAMenuFrameGeneralMiscDropDown, this:GetID());
	if ( this:GetID() == 1 ) then
		CT_RA_SORTTYPE = "group";
	elseif ( this:GetID() == 2 ) then
		CT_RA_SORTTYPE = "class";
	else
		CT_RA_SORTTYPE = "custom";
	end
	CT_RA_UpdateRaidGroup();
	CT_RAOptions_Update();
end

function CT_RAMenu_General_ResetWindows()
	CT_RAGroupDrag1:ClearAllPoints();
	CT_RAGroupDrag2:ClearAllPoints();
	CT_RAGroupDrag3:ClearAllPoints();
	CT_RAGroupDrag4:ClearAllPoints();
	CT_RAGroupDrag5:ClearAllPoints();
	CT_RAGroupDrag6:ClearAllPoints();
	CT_RAGroupDrag7:ClearAllPoints();
	CT_RAGroupDrag8:ClearAllPoints();
	CT_RAMTGroupDrag:ClearAllPoints();

	CT_RAGroupDrag1:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 950, -35);
	CT_RAGroupDrag2:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 950, -275);
	CT_RAGroupDrag3:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 855, -35);
	CT_RAGroupDrag4:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 855, -275);
	CT_RAGroupDrag5:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 760, -35);
	CT_RAGroupDrag6:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 760, -275);
	CT_RAGroupDrag7:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 665, -35);
	CT_RAGroupDrag8:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 665, -275);
	CT_RAMTGroupDrag:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 570, -35);
end

function CT_RAMenuGeneral_HideParty()
	CT_RA_HideParty = this:GetChecked();
	CT_RAMenu_CheckParty();
end

function CT_RAMenuDisplay_ChangeAC()
	local frame = this:GetParent();
	frame.r = CT_RA_DefaultAlertColor["r"];
	frame.g = CT_RA_DefaultAlertColor["g"];
	frame.b = CT_RA_DefaultAlertColor["b"];
	frame.swatchFunc = CT_RAMenuDisplay_SetAlertColor;
	frame.cancelFunc = CT_RAMenuDisplay_CancelAlertColor;
	CloseMenus();
	UIDropDownMenuButton_OpenColorPicker(frame);
end

function CT_RAMenuDisplay_SetAlertColor()
	local r, g, b = ColorPickerFrame:GetColorRGB();
	CT_RA_DefaultAlertColor["r"] = r;
	CT_RA_DefaultAlertColor["g"] = g;
	CT_RA_DefaultAlertColor["b"] = b;
	CT_RAMenuFrameGeneralDisplayAlertColorSwatchNormalTexture:SetVertexColor(r, g, b);
end

function CT_RAMenuDisplay_CancelAlertColor(val)
	CT_RA_DefaultAlertColor["r"] = val.r;
	CT_RA_DefaultAlertColor["g"] = val.g;
	CT_RA_DefaultAlertColor["b"] = val.b;
	CT_RAMenuFrameGeneralDisplayAlertColorSwatchNormalTexture:SetVertexColor(val.r, val.g, val.b);
end

function CT_RAMenuDisplay_ChangeTC()
	if ( CT_RA_ShowHP ) then
		local frame = this:GetParent();
		frame.r = CT_RA_PercentColor["r"];
		frame.g = CT_RA_PercentColor["g"];
		frame.b = CT_RA_PercentColor["b"];
		frame.swatchFunc = CT_RAMenuDisplayPercent_SetColor;
		frame.cancelFunc = CT_RAMenuDisplayPercent_CancelColor;
		CloseMenus();
		UIDropDownMenuButton_OpenColorPicker(frame);
	end
end

function CT_RAMenuDisplayPercent_SetColor()
	local r, g, b = ColorPickerFrame:GetColorRGB();
	CT_RA_PercentColor["r"] = r;
	CT_RA_PercentColor["g"] = g;
	CT_RA_PercentColor["b"] = b;
	CT_RAMenuFrameGeneralDisplayShowHPSwatchNormalTexture:SetVertexColor(r, g, b);
	CT_RA_UpdateRaidGroupColors();
end

function CT_RAMenuDisplayPercent_CancelColor(val)
	CT_RA_PercentColor["r"] = val.r;
	CT_RA_PercentColor["g"] = val.g;
	CT_RA_PercentColor["b"] = val.b;
	CT_RAMenuFrameGeneralDisplayShowHPSwatchNormalTexture:SetVertexColor(val.r, val.g, val.b);
	CT_RA_UpdateRaidGroupColors();
end

function CT_RAMenuGeneral_HideOffline()
	CT_RA_HideOffline = this:GetChecked();
	CT_RA_UpdateRaidGroup();
end

function CT_RAMenuGeneral_HideNA()
	CT_RA_HideNA = this:GetChecked();
	CT_RA_UpdateRaidGroup();
end

function CT_RAMenuGeneral_HideShort()
	CT_RA_HideShort = this:GetChecked();
	CT_RA_UpdateRaidGroup();
end

function CT_RAMenuBuff_ShowDebuffs()
	CT_RA_ShowDebuffs = this:GetChecked();
	CT_RA_UpdateRaidGroup();
end

function CT_RAMenuGeneral_HideBorder()
	CT_RA_HideBorder = this:GetChecked();
	CT_RA_UpdateRaidGroup();
	CT_RA_UpdateMTs();
end

-- Handle Misc section
CT_RA_PartyMembers = { };
CT_RA_CurrCast = nil;
CT_RA_InCombat = nil;
CT_RA_SpellCastDelay = 0.5;

function CT_RAMenuMisc_Slider_OnChange()
	local spell = CT_RA_ClassHealings[UnitClass("player")][this:GetID()];
	CT_RA_ClassHealings[UnitClass("player")][this:GetID()][3] = this:GetValue()/100;
	if ( type(spell[1]) == "table" ) then
		getglobal(this:GetName() .. "Text"):SetText(spell[1][1] .. " - " .. this:GetValue() .. "%");
	else
		getglobal(this:GetName() .. "Text"):SetText(spell[1] .. " - " .. this:GetValue() .. "%");
	end
end

function CT_RAMenuMisc_Slider_OnShow()

end

function CT_RAMenuMisc_Slider_Update(slider)
	slider = getglobal(slider);
	if ( UnitClass("player") and CT_RA_ClassHealings[UnitClass("player")] ) then -- Assumes there are two heals/healing class
		getglobal(slider:GetName().."High"):SetText("100%");
		getglobal(slider:GetName().."Low"):SetText("0%");
		slider.tooltipText = CT_RA_ClassHealings[UnitClass("player")][slider:GetID()][2];
		slider:SetMinMaxValues(0, 100);
		slider:SetValueStep(1);
		slider:Show();
		getglobal(slider:GetParent():GetName() .. "NoHealer"):Hide();
		getglobal(slider:GetParent():GetName() .. "Healer"):Show();

		local spell = CT_RA_ClassHealings[UnitClass("player")][slider:GetID()];
		slider:SetValue(spell[3]*100);
		if ( type(spell[1]) == "table" ) then
			getglobal(slider:GetName() .. "Text"):SetText(spell[1][1] .. " - " .. slider:GetValue() .. "%");
		else
			getglobal(slider:GetName() .. "Text"):SetText(spell[1] .. " - " .. slider:GetValue() .. "%");
		end
	else
		getglobal(slider:GetParent():GetName() .. "NoHealer"):Show();
		getglobal(slider:GetParent():GetName() .. "Healer"):Hide();
		slider:Hide();
	end
end

function CT_RAMenuMisc_Slider_InitLagSlider(slider)
	slider = getglobal(slider);
	if ( UnitClass("player") and CT_RA_ClassHealings[UnitClass("player")] ) then
		slider:Show();
		getglobal(slider:GetName().."High"):SetText("1.5 sec");
		getglobal(slider:GetName().."Low"):SetText("0.5 sec");
		getglobal(slider:GetName() .. "Text"):SetText("Check Time - " .. CT_RA_SpellCastDelay .. " sec");
		slider.tooltipText = "Adjust the time when the 'mana conserve' point checks your targets health.  If you set 0.5 sec, the heal will cancel 0.5 seconds before it would cast. However if you lag, you may want to set it higher, so it would check earlier before the cast would occur.";
		slider:SetMinMaxValues(0.5, 1.5);
		slider:SetValueStep(0.05);
		slider:SetValue(CT_RA_SpellCastDelay);
		slider:Show();
	else
		slider:Hide();
	end
end

function CT_RAMenuMisc_LagSlider_OnValueChanged()
	CT_RA_SpellCastDelay = floor(this:GetValue()*100+0.5)/100;
	getglobal(this:GetName() .. "Text"):SetText("Check Time - " .. CT_RA_SpellCastDelay .. " sec");
end

function CT_RAMenuMisc_Update()
	local currpeople = { };
	for i = 1, 4, 1 do
		getglobal("CT_RAMenuFrameMiscReportMember" .. i .. "CheckButton"):SetChecked(nil);
		if ( i <= GetNumPartyMembers() and UnitName("party" .. i) ) then
			currpeople[UnitName("party" .. i)] = 1;			
			if ( CT_RA_PartyMembers[UnitName("party" .. i)] ) then
				getglobal("CT_RAMenuFrameMiscReportMember" .. i .. "CheckButton"):SetChecked(1);
			end
			getglobal("CT_RAMenuFrameMiscReportMember" .. i .. "Text"):SetText("Party Member " .. i .. ": " .. UnitName("party" .. i));
			getglobal("CT_RAMenuFrameMiscReportMember" .. i .. "Text"):SetTextColor(1, 0.82, 0);
			getglobal("CT_RAMenuFrameMiscReportMember" .. i .. "CheckButton"):Enable();
		else
			getglobal("CT_RAMenuFrameMiscReportMember" .. i .. "Text"):SetText("Party Member " .. i .. ": " .. "<None>");
			getglobal("CT_RAMenuFrameMiscReportMember" .. i .. "Text"):SetTextColor(0.3, 0.3, 0.3);
			getglobal("CT_RAMenuFrameMiscReportMember" .. i .. "CheckButton"):Disable();
		end
	end
	for k, v in CT_RA_PartyMembers do
		if ( not currpeople[k] ) then
			v = nil;
		end
	end
end

function CT_RAMenuMisc_ReportPerson()
	CT_RA_PartyMembers[UnitName("party" .. this:GetParent():GetID())] = this:GetChecked();
	if ( not this:GetChecked() ) then
		CT_RA_SendMessage("PR " .. UnitName("party" .. this:GetParent():GetID()), 1);
	else
		local unit = "party" .. this:GetParent():GetID();
		local health = floor(UnitHealth(unit)/UnitHealthMax(unit)*100+0.5);
		if ( UnitIsDead(unit) or UnitHealth(unit) <= 1 ) then
			health = -1;
		end
		CT_RA_SendMessage("PH " .. UnitName(unit) .. " " .. health);
		local mana = floor(UnitMana(unit)/UnitManaMax(unit)*100+0.5);
		CT_RA_SendMessage("PM " .. UnitName(unit) .. " " .. mana);
	end
end

function CT_RAMenuMisc_Schedule(time)
	this.update = time;
end

function CT_RAMenuMisc_OnUpdate(elapsed)
	if ( this.scaleupdate ) then
		this.scaleupdate = this.scaleupdate - elapsed;
		if ( this.scaleupdate <= 0 ) then
			this.scaleupdate = nil;
			if ( CT_RA_WindowScaling ) then
				for i = 1, 40, 1 do
					if ( i <= 8 ) then
						getglobal("CT_RAGroupDrag" .. i):SetWidth(CT_RAGroup1:GetWidth()*CT_RA_WindowScaling+(22*CT_RA_WindowScaling));
						getglobal("CT_RAGroupDrag" .. i):SetHeight(CT_RAMember1:GetHeight()*CT_RA_WindowScaling/2);
						getglobal("CT_RAGroup" .. i):SetScale(CT_RA_WindowScaling);
					end
					getglobal("CT_RAMember" .. i):SetScale(CT_RA_WindowScaling);
				end
			end
			if ( CT_RA_MTScaling ) then
				for i = 1, 5, 1 do
					getglobal("CT_RAMTGroupMember" .. i):SetScale(CT_RA_MTScaling);
				end
				CT_RAMTGroup:SetScale(CT_RA_MTScaling);
				CT_RAMTGroupDrag:SetWidth(CT_RAMTGroup:GetWidth()*CT_RA_MTScaling+(22*CT_RA_MTScaling));
				CT_RAMTGroupDrag:SetHeight(CT_RAMTGroupMember1:GetHeight()*CT_RA_MTScaling/2);
			end
		end
	end

	if ( this.update ) then
		this.update = this.update - elapsed;
		if ( this.update <= 0 ) then
			this.update = nil;
			CT_RAMenuMisc_CheckTargetHealth();
			CT_RA_CurrCast = nil;
		end
	end
end

function CT_RAMenuMisc_CheckTargetHealth()
	if ( not CT_RA_CurrCast or IsControlKeyDown() or CT_RA_InCombat ) then return; end
	for k, v in CT_RA_ClassHealings[UnitClass("player")] do
		if ( type(v[1]) == "table" and v[3] < 1 ) then
			for key, val in v[1] do
				if ( val == CT_RA_CurrCast[1] ) then
					if ( CT_RA_CurrCast[2] == "target" ) then
						if ( not UnitExists("target") or CT_RA_CurrCast[3] ~= UnitName("target") ) then
							return; -- Can't process health here
						end
					end
					if ( UnitExists(CT_RA_CurrCast[2]) and UnitHealth(CT_RA_CurrCast[2])/UnitHealthMax(CT_RA_CurrCast[2]) >= v[3] ) then
						CT_RA_Print("<CTMod> Aborted spell '|c00FFFFFF" .. CT_RA_CurrCast[1] .. "|r'.", 1, 0.5, 0);
						SpellStopCasting();
						return;
					end
				end
			end
		elseif ( v[1] == CT_RA_CurrCast[1] and v[3] < 1 ) then
			if ( CT_RA_CurrCast[2] == "target" ) then
				if ( not UnitExists("target") or CT_RA_CurrCast[3] ~= UnitName("target") ) then
					return; -- Can't process health here
				end
			end
			if ( UnitExists(CT_RA_CurrCast[2]) and UnitHealth(CT_RA_CurrCast[2])/UnitHealthMax(CT_RA_CurrCast[2]) >= v[3] ) then
				CT_RA_Print("<CTMod> Aborted spell '|c00FFFFFF" .. CT_RA_CurrCast[1] .. "|r'.", 1, 0.5, 0);
				SpellStopCasting();
				return;
			end
		end
	end
end

function CT_RAMenuMisc_OnEvent(event)
	if ( event == "PARTY_MEMBERS_CHANGED" ) then
		CT_RAMenuMisc_Update();
	elseif ( event == "SPELLCAST_START" and CT_RA_ClassHealings[UnitClass("player")] ) then
		if ( not CT_RA_SpellTarget and UnitExists("target") and UnitIsFriend("player", "target") ) then
			CT_RA_SpellTarget = "target";
		elseif ( not CT_RA_SpellTarget and UnitExists("mouseover") ) then
			return; -- Can't check on mouseover :(
		end
		if ( not CT_RA_SpellTarget ) then return; end
		for k, v in CT_RA_ClassHealings[UnitClass("player")] do
			if ( type(v[1]) == "table" ) then
				for key, val in v[1] do
					if ( val == arg1 ) then
						CT_RA_CurrCast = { arg1, CT_RA_SpellTarget, UnitName(CT_RA_SpellTarget) };

						local time = (arg2/1000)-CT_RA_SpellCastDelay;
						if ( time < 0 ) then
							time = 0;
						end
						CT_RAMenuMisc_Schedule(time);
						return;
					end
				end
			elseif ( v[1] == arg1 ) then
				CT_RA_CurrCast = { arg1, CT_RA_SpellTarget, UnitName(CT_RA_SpellTarget) };
				local time = (arg2/1000)-CT_RA_SpellCastDelay;
				if ( time < 0 ) then
					time = 0;
				end
				CT_RAMenuMisc_Schedule(time);
				return;
			end
		end
	elseif ( event == "SPELLCAST_INTERRUPTED" or event == "SPELLCAST_STOP" or event == "SPELLCAST_FAILED" ) then
		CT_RA_CurrCast = nil;
		CT_RA_SpellTarget = nil;
	elseif ( event == "PLAYER_REGEN_ENABLED" ) then
		CT_RA_InCombat = nil;
	elseif ( event == "PLAYER_REGEN_DISABLED" ) then
		CT_RA_InCombat = 1;
	end
end


-- Scaling

function CT_RAMenuAdditional_Scaling_OnShow()
	getglobal(this:GetName().."High"):SetText("150%");
	getglobal(this:GetName().."Low"):SetText("50%");
	if ( not CT_RA_WindowScaling ) then
		CT_RA_WindowScaling = floor(CT_RAGroup1:GetScale()*100+0.5)/100;
	end
	getglobal(this:GetName() .. "Text"):SetText("Group Scaling - " .. floor(CT_RA_WindowScaling*100+0.5) .. "%");

	this:SetMinMaxValues(0.5, 1.5);
	this:SetValueStep(0.01);
	this:SetValue(CT_RA_WindowScaling);
end

function CT_RAMenuAdditional_Scaling_OnValueChanged()
	CT_RA_WindowScaling = floor(this:GetValue()*100+0.5)/100;
	getglobal(this:GetName() .. "Text"):SetText("Group Scaling - " .. floor(this:GetValue()*100+0.5) .. "%");
	for i = 1, 40, 1 do
		if ( i <= 8 ) then
			getglobal("CT_RAGroup" .. i):SetScale(CT_RA_WindowScaling);
			getglobal("CT_RAGroupDrag" .. i):SetWidth(CT_RAGroup1:GetWidth()*CT_RA_WindowScaling+(22*CT_RA_WindowScaling));
			getglobal("CT_RAGroupDrag" .. i):SetHeight(CT_RAMember1:GetHeight()*CT_RA_WindowScaling/2);
		end
		getglobal("CT_RAMember" .. i):SetScale(CT_RA_WindowScaling);
	end
end

function CT_RAMenuAdditional_ScalingMT_OnShow()
	getglobal(this:GetName().."High"):SetText("150%");
	getglobal(this:GetName().."Low"):SetText("50%");
	if ( not CT_RA_MTScaling ) then
		CT_RA_MTScaling = floor(CT_RAMTGroup:GetScale()*100+0.5)/100;
	end
	getglobal(this:GetName() .. "Text"):SetText("MT Scaling - " .. floor(CT_RA_MTScaling*100+0.5) .. "%");

	this:SetMinMaxValues(0.5, 1.5);
	this:SetValueStep(0.01);
	this:SetValue(CT_RA_MTScaling);
end

function CT_RAMenuAdditional_ScalingMT_OnValueChanged()
	CT_RA_MTScaling = floor(this:GetValue()*100+0.5)/100;
	getglobal(this:GetName() .. "Text"):SetText("MT Scaling - " .. floor(this:GetValue()*100+0.5) .. "%");
	for i = 1, 5, 1 do
		getglobal("CT_RAMTGroupMember" .. i):SetScale(CT_RA_MTScaling);
	end
	CT_RAMTGroup:SetScale(CT_RA_MTScaling);

	CT_RAMTGroupDrag:SetWidth(CT_RAMTGroup:GetWidth()*CT_RA_MTScaling+(22*CT_RA_MTScaling));
	CT_RAMTGroupDrag:SetHeight(CT_RAMTGroupMember1:GetHeight()*CT_RA_MTScaling/2);
end

-- Spam Control
CT_RA_Comm_HPChangeThreshold = 3;
CT_RA_Comm_MPChangeThreshold = 10;
CT_RA_Comm_MinMessageInterval = 0.1;
CT_RA_Comm_MTHPChangeThreshold = 3;
CT_RA_Comm_MTMPChangeThreshold = 10;

function CT_RAMenuAdditional_SC_OnShow()
	local vars = { CT_RA_Comm_HPChangeThreshold, CT_RA_Comm_MPChangeThreshold, CT_RA_Comm_MTHPChangeThreshold, CT_RA_Comm_MTMPChangeThreshold };
	local type = { "Health", "Mana", "Health", "Mana" };
	getglobal(this:GetName().."High"):SetText("100%");
	getglobal(this:GetName().."Low"):SetText("1%");
	getglobal(this:GetName() .. "Text"):SetText(type[this:GetID()] .. " - " .. vars[this:GetID()] .. "%");
	this:SetMinMaxValues(1, 100);
	this:SetValueStep(1);
	this:SetValue(vars[this:GetID()]);
	if ( this:GetID() <= 2 ) then
		this.tooltipText = "This also affects party members you report health and mana for.";
	end
end

function CT_RAMenuAdditional_SC_OnValueChanged()
	if ( this:GetID() == 1 ) then
		CT_RA_Comm_HPChangeThreshold = this:GetValue();
	elseif ( this:GetID() == 2 ) then
		CT_RA_Comm_MPChangeThreshold = this:GetValue();
	elseif ( this:GetID() == 3 ) then
		CT_RA_Comm_MTHPChangeThreshold = this:GetValue();
	else
		CT_RA_Comm_MTMPChangeThreshold = this:GetValue();
	end
	local type = { "Health", "Mana", "Health", "Mana" };
	getglobal(this:GetName() .. "Text"):SetText(type[this:GetID()] .. " - " .. this:GetValue() .. "%");
end

function CT_RAMenuAdditional_SpamControl_OnShow()
	getglobal(this:GetName().."High"):SetText("5 sec");
	getglobal(this:GetName().."Low"):SetText("0.1 sec");
	getglobal(this:GetName() .. "Text"):SetText("Minimum Interval - " .. CT_RA_Comm_MinMessageInterval .. " sec");

	this:SetMinMaxValues(0.1, 5);
	this:SetValueStep(0.1);
	this:SetValue(CT_RA_Comm_MinMessageInterval);
end

function CT_RAMenuAdditional_SpamControl_OnValueChanged()
	CT_RA_Comm_MinMessageInterval = floor(this:GetValue()*100+0.5)/100;
	getglobal(this:GetName() .. "Text"):SetText("Minimum Interval  - " .. CT_RA_Comm_MinMessageInterval .. " sec");
end