-------------------------------------------------------------------------------
-- contants
-------------------------------------------------------------------------------

BINDING_HEADER_QSATITLE = "Quu Spell Alert";
QSA_VERSION       = "1.1.3";
QSA_SLASH_COMMAND = "/qsa";

-------------------------------------------------------------------------------
-- controll variables
-------------------------------------------------------------------------------

-- the basics
QSA_Enabled = true;
QSA_CombatOnly = true;
QSA_TargetOnly = false;
QSA_EmoteMode = true;
QSA_GainMode = true;
QSA_FadeMode = false; -- this is disbaled by default.. otherwise SPAM!!!!!
QSA_Hide = false;
-- this is not stored... it must be turned on each time!!!
local QSA_Report;


-- this is the last caster that was captured
local QSA_LastTarget;

-- only enable this if you know what you are doing!!!!!
local QSA_Debug = false;
QSA_DebugArray = { };

-- then the timer stuff
local QSA_Trip;
local QSA_Timer;
local QSA_AlertMessage;

-------------------------------------------------------------------------------
-- Alert functions
-------------------------------------------------------------------------------
-- these are the text RGBA settings... (saved and changed via the colorchooser)
-- do not edit these here unless you are making a complication pak
QSA_RED   = 1.0;
QSA_GREEN = 0.1;
QSA_BLUE  = 0.1;
QSA_ALPHA = 1.0;

function QSA_println( Message)
	DEFAULT_CHAT_FRAME:AddMessage(Message, 1.0, 1.0, 1.0);
end
function QSA_PlayAlertSount()
	--need a good sound name (found in the QC stuff
	PlaySoundFile("Sound\\Doodad\\BellTollAlliance.wav");
end
function QSA_Banner(msg)
	QuuSpellAlertFrame:AddMessage(msg, QSA_RED, QSA_GREEN, QSA_BLUE, QSA_ALPHA, UIERRORS_HOLD_TIME);
end
function QSA_SendReport(msg)
	if (QSA_Report) then
		if (GetNumRaidMembers() > 0) then
			SendChatMessage(msg, "RAID");
		elseif (UnitExists("party1")) then
			SendChatMessage(msg, "PARTY");
		else
			SendChatMessage(msg, "YELL");
		end
	end
end

-------------------------------------------------------------------------------
-- the colour picking stuff (and alpha)
-------------------------------------------------------------------------------
-- first function
function QSA_ChooseColor()
	ColorPickerFrame.func = QSA_SetColor;
	ColorPickerFrame.hasOpacity = true;
	ColorPickerFrame.opacityFunc = QSA_SetOpacity;
	ColorPickerFrame.opacity = 1.0 - QSA_ALPHA;
	ColorPickerFrame:SetColorRGB(QSA_RED, QSA_GREEN, QSA_BLUE);
	ColorPickerFrame.previousValues = {r = QSA_RED, g = QSA_GREEN, b = QSA_BLUE, opacity = (1.0 - QSA_ALPHA)};
	ColorPickerFrame.cancelFunc = QSA_CancelColour;
	ShowUIPanel(ColorPickerFrame);
end

function QSA_SetColor()
	QSA_RED, QSA_GREEN, QSA_BLUE = ColorPickerFrame:GetColorRGB();
end
function QSA_SetOpacity()
	QSA_ALPHA = 1.0 - OpacitySliderFrame:GetValue();
end
function QSA_CancelColour()
	QSA_RED   = ColorPickerFrame.previousValues.r;
	QSA_GREEN = ColorPickerFrame.previousValues.g;
	QSA_BLUE  = ColorPickerFrame.previousValues.b;
	QSA_ALPHA = 1.0 - ColorPickerFrame.previousValues.opacity;
end

-------------------------------------------------------------------------------
-- font size thingies (broken... no idea how!)
-------------------------------------------------------------------------------
function QSA_SetFontSize( fontSize)
	-- one of these should work
	--QuuSpellAlertFrame:SetFontHeight(fontSize);
	--QuuSpellAlertFrameFont:SetFontHeight(fontSize);
	-- if this works make a quick menu with the different font sizes
end



-------------------------------------------------------------------------------
-- the init and configuration
-------------------------------------------------------------------------------
function QSA_Init()
	QSA_Status();
	-- Register our slash command
	SLASH_QSA1 = QSA_SLASH_COMMAND;
	SlashCmdList["QSA"] = function(msg)
		QSA_Command(msg);
	end

	if (QSA_Hide) then
		QuuSpellAlertAnchor:Hide();
	end

	-- setup the non stored variables to the default settings
	QSA_Report = false;
	QSA_LastTarget = nil;
	QSA_Debug = false;
	QSA_Trip = true;
	QSA_Timer = nil;
	QSA_AlertMessage = "<ERROR>";
	
end

function QSA_Command(msg)
	if( msg ) then
		local command = string.lower(msg);
		if( command == "" ) then
			QSA_println(QSA_SLASH_COMMAND.." ["..QSA_MACRO_STATUS.."|"..QSA_MACRO_TOGGLE.."|...]");
			QSA_println("  "..QSA_MACRO_STATUS.."  "..QSA_MACRO_STATUS_DESC);
			QSA_println("  "..QSA_MACRO_TOGGLE.."  "..QSA_MACRO_TOGGLE_DESC);
			QSA_println("  "..QSA_MACRO_REPORT.."  "..QSA_MACRO_REPORT_DESC);
			QSA_println("  "..QSA_MACRO_TARGET.."  "..QSA_MACRO_TARGET_DESC);
			QSA_println("  "..QSA_MACRO_SHOW.."  "..QSA_MACRO_SHOW_DESC);
			QSA_println("  "..QSA_MACRO_EMOTE.."  "..QSA_MACRO_EMOTE_DESC);
			QSA_println("  "..QSA_MACRO_GAIN.."  "..QSA_MACRO_GAIN_DESC);
			QSA_println("  "..QSA_MACRO_FADE.."  "..QSA_MACRO_FADE_DESC);
			QSA_println("  "..QSA_MACRO_COMBAT.."  "..QSA_MACRO_COMBAT_DESC);
			QSA_println("  "..QSA_MACRO_TRGNLY.."  "..QSA_MACRO_TRGNLY_DESC);
			QSA_println("  "..QSA_MACRO_TEST.."  "..QSA_MACRO_TEST_DESC);
			--QSA_println("  "..QSA_MACRO_DEBUG.."  "..QSA_MACRO_DEBUG_DESC);
			--QSA_println("  "..QSA_MACRO_DEBUGCLEAR.."  "..QSA_MACRO_DEBUGCLEAR_DESC);
		elseif (command == QSA_MACRO_STATUS ) then
			QSA_Status();
		elseif (command == QSA_MACRO_TOGGLE ) then
			QSA_Enabled = not QSA_Enabled;
			QSA_Status();
		elseif (command == QSA_MACRO_REPORT ) then
			QSA_Report = not QSA_Report;
			QSA_Status();
		elseif (command == QSA_MACRO_TARGET ) then
			QSA_TargetLast();
		elseif (command == QSA_MACRO_SHOW ) then
			QSA_Hide = false;
			QuuSpellAlertAnchor:Show();
			QuuSpellAlertTimerFrame:Show();
		elseif (command == QSA_MACRO_EMOTE ) then
			QSA_EmoteMode = not QSA_EmoteMode;
			QSA_Status();
		elseif (command == QSA_MACRO_GAIN ) then
			QSA_GainMode = not QSA_GainMode;
			QSA_Status();
		elseif (command == QSA_MACRO_FADE ) then
			QSA_FadeMode = not QSA_FadeMode;
			QSA_Status();
		elseif (command == QSA_MACRO_COMBAT ) then
			QSA_CombatOnly = not QSA_CombatOnly;
			QSA_Status();
		elseif (command == QSA_MACRO_TRGNLY ) then
			QSA_TargetOnly = not QSA_TargetOnly;
			QSA_Status();
		elseif (command == QSA_MACRO_TEST ) then
			QSA_Test();
		elseif (command == QSA_MACRO_DEBUG) then
			QSA_Debug = not QSA_Debug;
			QSA_Status();
		elseif (command == QSA_MACRO_DEBUGCLEAR) then
			QSA_DebugArray = nil;
			QSA_DebugArray = { };
			QSA_println( QSA_MACRO_DEBUGCLEAR_MSG);
		else
			QSA_println( QSA_MACRO_ERROR);
		end
	end
end

function QSA_Test()
	-- I am not going to localize the test strings
	
	-- adding a timer
	QSA_Trip = false;
	QSA_AlertMessage = "Timed timer has finished... BOO!"
	QSA_Timer = 10;

	-- and displaying some information
	QSA_Banner("This is a test.");
	QSA_Banner("If this had been a real spell...");
	QSA_Banner("You would be dead!");
	QSA_PlayAlertSount();
end

function QSA_TargetLast()
	if (QSA_LastTarget ~= nil) then
		TargetByName(QSA_LastTarget);
	end
end

function QSA_Status()
	QSA_println( "Quu Spell Alert "..QSA_VERSION);
	if (QSA_Enabled) then
		QSA_println( QSA_STATUS_ENABLED);
		if (QSA_Report) then
			QSA_println( QSA_REPORT_ENABLED);
		end
		if (QSA_EmoteMode) then
			QSA_println( QSA_EMOTE_ENABLED);
		end
		if (QSA_GainMode) then
			QSA_println( QSA_GAIN_ENABLED);
		end
		if (QSA_FadeMode) then
			QSA_println( QSA_FADE_ENABLED);
		end
		if (QSA_CombatOnly) then
			QSA_println( QSA_TARGET_ENABLED);
		end
		if (QSA_TargetOnly) then
			QSA_println( QSA_TRGONLY_ENABLED)
		end
		if (QSA_Debug) then
			QSA_println( QSA_DEBUG_ENABLED)
		end
	else
		QSA_println( QSA_STATUS_DISBALED);
	end
end


-------------------------------------------------------------------------------
-- the display logic
-------------------------------------------------------------------------------

function QSA_ReplaceTokens( originalString, caster, effect)
	return string.gsub( string.gsub( originalString, "$c", caster), "$e", effect);
end

-- when a spell is beging to be cast
function QSA_Casting( Creature, Spell) 
	-- if we know to ignore it... ingore it all the way!!!!
	if (QSA_IgnoreSpells[Spell]) then
		return;
	end

	if (QSA_IsInParty(Creature)) then
		return;
	end

	-- if we are storing the debug info... store it
	if (QSA_Debug) then
		-- record the spell based on what creater did it
		if ( not QSA_DebugArray.spell) then
			QSA_DebugArray.spell = { };
		end
		if ( not QSA_DebugArray.spell[Creature]) then
			QSA_DebugArray.spell[Creature] = { };
		end
		QSA_DebugArray.spell[Creature][Spell] = true;
	end

	-- check for "target only" mode
	if (QSA_TargetOnly and (UnitExists("target"))) then
		if (UnitName("target") ~= Creature) then
			return;
		end
	end

	-- now... spew off stuff based on the details
	QSA_LastTarget = Creature;
	QSA_Banner( QSA_ReplaceTokens(QSA_CASTING_BANNER, Creature, Spell));
	if (QSA_ImportantSpells[Spell]) then
		QSA_SendReport( QSA_ReplaceTokens(QSA_CASTING_REPORT, Creature, Spell));
		QSA_PlayAlertSount()
	end
end

-- Some Spells are instant cast
function QSA_Spell( Creature, Spell) 
	-- the ones we ignore... we ignore
	if (QSA_IgnoreSpells[Spell]) then
		return;
	end

	if (QSA_IsInParty(Creature)) then
		return;
	end
	
	if (QSA_Debug) then
		if ( not QSA_DebugArray.spell) then
			QSA_DebugArray.spell = { };
		end
		if ( not QSA_DebugArray.spell[Creature]) then
			QSA_DebugArray.spell[Creature] = { };
		end
		QSA_DebugArray.spell[Creature][Spell] = true;
	end

	-- check for target only mode
	if (QSA_TargetOnly and (UnitExists("target"))) then
		if (UnitName("target") ~= Creature) then
			return;
		end
	end

	-- spew out stuff if needed
	QSA_LastTarget = Creature;
	QSA_Banner( QSA_ReplaceTokens(QSA_SPELL_BANNER, Creature, Spell));
	if (QSA_ImportantSpells[Spell]) then
		QSA_SendReport( QSA_ReplaceTokens(QSA_SPELL_REPORT, Creature, Spell));
		QSA_PlayAlertSount()
	end
end

function QSA_Gain( Creature, Effect) 
	if (QSA_IgnoreEffects[Effect]) then
		return;
	end

	if (QSA_IsInParty(Creature)) then
		return;
	end

	-- record for debug reasons
	if (QSA_Debug) then
		-- record the effect based on what creater did it
		if ( not QSA_DebugArray.gain) then
			QSA_DebugArray.gain = { };
		end
		if ( not QSA_DebugArray.gain[Creature]) then
			QSA_DebugArray.gain[Creature] = { };
		end
		QSA_DebugArray.gain[Creature][Effect] = true;
	end

	if (QSA_ImportantEffects[Effect]) then
		-- important effects are ALWAYS done, even if disabled or target only
		QSA_LastTarget = Creature;
		QSA_Banner( QSA_ReplaceTokens(QSA_GAIN_BANNER, Creature, Effect));
		QSA_SendReport( QSA_ReplaceTokens(QSA_GAIN_REPORT, Creature, Effect));
		QSA_PlayAlertSount()
	else
		if (not QSA_GainMode) then
			return;
		end

		if (QSA_TargetOnly and (UnitExists("target"))) then
			if (UnitName("target") ~= Creature) then
				return;
			end
		end

		QSA_LastTarget = Creature;
		QSA_Banner( QSA_ReplaceTokens(QSA_GAIN_BANNER, Creature, Effect));
	end	

end

function QSA_Fade( Creature, Effect) 
	if (QSA_IgnoreEffects[Effect]) then
		return;
	end

	if (QSA_IsInParty(Creature)) then
		return;
	end

	if (QSA_Debug) then
		-- record the effect based on what creater did it
		if ( not QSA_DebugArray.fade) then
			QSA_DebugArray.fade = { };
		end
		if ( not QSA_DebugArray.fade[Creature]) then
			QSA_DebugArray.fade[Creature] = { };
		end
		QSA_DebugArray.fade[Creature][Effect] = true;
	end

	if (QSA_ImportantEffects[Effect]) then
		-- ALWAYS display important events
		QSA_LastTarget = Creature;
		QSA_Banner( QSA_ReplaceTokens(QSA_FADE_BANNER, Creature, Effect));
		QSA_SendReport( QSA_ReplaceTokens(QSA_FADE_REPORT, Creature, Effect));
		QSA_PlayAlertSount()
	else
		if (not QSA_FadeMode) then
			return;
		end
		
		if (QSA_TargetOnly and (UnitExists("target"))) then
			if (UnitName("target") ~= Creature) then
				return;
			end
		end
		
		QSA_LastTarget = Creature;
		QSA_Banner( QSA_ReplaceTokens(QSA_FADE_BANNER, Creature, Effect));
	end	
end

function QSA_Emote( Creature, Emote) 
	if (QSA_IgnoreEmotes[Emote]) then
		return;
	end
	if (QSA_IsInParty(Creature)) then
		return;
	end
	if (QSA_Debug) then
		-- record the emote based on what creater did it
		if ( not QSA_DebugArray.emote) then
			QSA_DebugArray.emote = { };
		end
		if ( not QSA_DebugArray.emote[Creature]) then
			QSA_DebugArray.emote[Creature] = { };
		end
		QSA_DebugArray.emote[Creature][Emote] = true;
	end

	if (QSA_ImportantEmotes[Emote]) then
		-- always display important emotes
		QSA_LastTarget = Creature;
		QSA_Banner( QSA_ReplaceTokens(QSA_EMOTE_BANNER, Creature, Emote));
		QSA_SendReport( QSA_ReplaceTokens(QSA_EMOTE_REPORT, Creature, Emote));
		QSA_PlayAlertSount()
	else
		if (not QSA_EmoteMode) then
			return
		end
		
		if (QSA_TargetOnly and (UnitExists("target"))) then
			if (UnitName("target") ~= Creature) then
				return;
			end
		end
		
		QSA_LastTarget = Creature;
		QSA_Banner( QSA_ReplaceTokens(QSA_EMOTE_BANNER, Creature, Emote));
	end

end

-------------------------------------------------------------------------------
-- name check function
-------------------------------------------------------------------------------
function QSA_IsInParty( Name)
	if (Name == UnitName("player")) then
		return true;
	elseif (Name == UnitName("pet")) then
		return true;
	elseif (Name == UnitName("party1")) then
		return true;
	elseif (Name == UnitName("party2")) then
		return true;
	elseif (Name == UnitName("party3")) then
		return true;
	elseif (Name == UnitName("party4")) then
		return true;
-- enable for 1.5.0
--	elseif (Name == UnitName("party1pet")) then
--		return true;
--	elseif (Name == UnitName("party2pet")) then
--		return true;
--	elseif (Name == UnitName("party3pet")) then
--		return true;
--	elseif (Name == UnitName("party4pet")) then
--		return true;
	else
		local numRaidMembers = GetNumRaidMembers();
		if (numRaidMembers > 0) then
			-- we are in a raid
			for i=1, numRaidMembers do
				RaidName = GetRaidRosterInfo(i);
				if ( Name == RaidName) then
					return true;
				end
-- enable for 1.5.0				
--				if ( Name == UnitName("raid"..i.."pet")) then
--					return true;
--				end
			end
		end
	end
	return false;
end

-------------------------------------------------------------------------------
-- the timer functions... this does the countdowns!
-------------------------------------------------------------------------------

-- need to make the countdown visible
function QSA_OnUpdate(arg1)
	if (QSA_Timer ~= nil) then
		-- we have a current timer to deal with
		
		-- show the timer frame!
		if (not QuuSpellAlertTimerFrame:IsVisible()) then
			QuuSpellAlertTimerFrame:Show();
		end

		-- display the data... or count down further
		if (QSA_Timer < 0) then
			QSA_Banner( QSA_AlertMessage);
			QSA_SendReport(QSA_AlertMessage);
			QSA_PlayAlertSount();
			QSA_Timer = nil;
			QSA_Trip = true;
			QuuSpellAlertTimerFrameText:SetText("Time Left");
		else
			QSA_Timer = QSA_Timer - arg1;

			-- update the clock value!
			if (QSA_Timer > 0) then
				-- remove the fraction
				local timerVal = floor(QSA_Timer);
				-- get the minutes (rare... but we might need it)
				local min = floor(timerVal / 60);
				-- now get the seconds
				local sec = timerVal - (min*60);
				-- then pad for the seconds being single digit
				if (sec < 10) then
					QuuSpellAlertTimerFrameText:SetText(min..":0"..sec);
				else
					QuuSpellAlertTimerFrameText:SetText(min..":"..sec);
				end
			else
				QuuSpellAlertTimerFrameText:SetText("00:00");
			end

		end
		
	else
		-- only hide it if the anchor frame is also hidden
		if (not QuuSpellAlertAnchor:IsVisible()) then
			if (QuuSpellAlertTimerFrame:IsVisible()) then
				QuuSpellAlertTimerFrame:Hide();
			end
		end
	end
end

-------------------------------------------------------------------------------
-- event block... this listens and deals with all those pesky events
-------------------------------------------------------------------------------

-- this is all the events that might trip up ones we care about
QSA_PreConsumerStrings = {
	AURAADDEDSELFHELPFUL,
	AURADISPELSELF,
	AURAREMOVEDSELF,
	GENERICPOWERGAIN_OTHER,
	GENERICPOWERGAIN_SELF, 
	PERIODICAURAHEALOTHEROTHER,
	PERIODICAURAHEALOTHERSELF,
	PERIODICAURAHEALSELFOTHER,
	PERIODICAURAHEALSELFSELF,
	POWERGAIN_OTHER,
	POWERGAIN_SELF,
	SPELLCASTGOSELF,
	SPELLCASTSELFSTART,
	SPELLEXTRAATTACKSOTHER,
	SPELLEXTRAATTACKSOTHER_SINGULAR,
	SPELLEXTRAATTACKSSELF,
	SPELLEXTRAATTACKSSELF_SINGULAR,
	SPELLPERFORMSELFSTART,
	SPELLPOWERDRAINOTHEROTHER,
	SPELLPOWERDRAINOTHERSELF,
	SPELLPOWERLEECHOTHEROTHER,
	SPELLPOWERLEECHOTHERSELF,
	SPELLPOWERLEECHSELFOTHER,
}
-- this function converts one of the globals into a search string
function QSA_FormatGlobalStrings( globalString)
	local res = globalString;
	
	-- first reformat the "global" so it can be gsubed
	local i;
	for i = 1, string.len(res) do
		if (string.sub(res, i, i) == "%") then
			if (i == 1) then
				res = "$"..string.sub(res, 2);
			else
				res = string.sub(res, 1, i -1).."$"..string.sub(res, i + 1);
			end
		end
	end
	res = string.gsub(res, "$s", "(.+)");
	res = string.gsub(res, "$d", "(%d)");
	return res;
end


function QSA_Event(event, arg1, arg2)
	if (not QSA_Enabled) then
		return;
	end
	
	if ((not UnitAffectingCombat("player")) and QSA_CombatOnly) then
		return;
	end
	
	if (
		(event == "CHAT_MSG_EMOTE") or 
		-- (event == "CHAT_MSG_TEXT_EMOTE") or
		(event == "CHAT_MSG_MONSTER_EMOTE")
	) then
		QSA_Emote(arg2, arg1);
		return;
	elseif (
		(event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE") or 
		(event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE") or 
		(event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE")
	) then

		if (QSA_Debug) then
			if ( not QSA_DebugArray.periodic) then
				QSA_DebugArray.periodic = { };
			end
			QSA_DebugArray.periodic[arg1] = event;
		end

		-- Baron Geddon from CQGeddon mode by Sudo
		-- this is "you are .." or "Blah is afflicted by Living Bomb" style format
		local _, _, player = string.find(arg1, QSA_Geddon_String);
		if (player) then
			if (player == YOU) then
				QSA_Trip = false;
				player = UnitName("player")
				-- not going to use send message here... can only be while in a raid anyway
				-- and I want it always to send... even if reporting is off
				SendChatMessage(string.gsub(QSA_Geddon_Raid_Warning, "$p", player), "RAID");
				QSA_Banner(QSA_Geddon_Banner_MSG);
				--QSA_Banner("You have 10 seconds! Make your time!");
				QSA_PlayAlertSount();
				-- go ahead and show the timer
				QSA_AlertMessage = QSA_Geddon_Delay_MSG;
				QSA_Timer = 8;
				return;
			elseif (QSA_Report) then
				SendChatMessage(QSA_Geddon_Banner_MSG, "WHISPER", this.language, player);
				SendChatMessage(string.gsub(QSA_Geddon_Raid_Warning, "$p", player), "RAID");
				return;
			end
		end

		-- now for the more generic ConquestguildXXX timers
		if (QSA_Trip) then
			for afflictionSTR, detailArray in QSA_Affliction_Timers do
				if (string.find(arg1, afflictionSTR)) then
					QSA_Trip = false;
					QSA_Banner( detailArray["Banner"]);
					QSA_SendReport(detailArray["Report"]);
					QSA_PlayAlertSount();
					-- now for the delayed alert
					QSA_AlertMessage = detailArray["Delay_MSG"]
					QSA_Timer = detailArray["Timer"];
					return;
				end
			end
		end

	else

		-- first remove any troublesome strings that might trip up the real ones
		for key, value in QSA_PreConsumerStrings do
			for _  in string.gfind(arg1,QSA_FormatGlobalStrings(value)) do
				if (QSA_Debug) then
					if ( not QSA_DebugArray.preConsumed) then
						QSA_DebugArray.preConsumed = { };
					end
					QSA_DebugArray.preConsumed[arg1] = event;
				end
				return;
			end
		end
		

		-- now parse the different spells we listen to
		local mob = "<ERROR>";
		local effect = "<ERROR>";

		for mob, effect in string.gfind(arg1,QSA_FormatGlobalStrings(SPELLCASTOTHERSTART)) do
			QSA_Casting(mob, effect);
			return;
		end

		for mob, effect in string.gfind(arg1,QSA_FormatGlobalStrings(SPELLPERFORMOTHERSTART)) do
			QSA_Casting(mob, effect);
			return;
		end

		for mob, effect in string.gfind(arg1,QSA_FormatGlobalStrings(SPELLCASTGOOTHER)) do
			if (string.find(effect, QSA_TOTEM)) then
				QSA_Spell(mob, effect);
			else
				if (QSA_Debug) then
					if (not QSA_IsInParty(mob)) then
						if ( not QSA_DebugArray.spellIgnored) then
							QSA_DebugArray.spellIgnored = { };
						end
						if ( not QSA_DebugArray.spellIgnored[mob]) then
							QSA_DebugArray.spellIgnored[mob] = { };
						end
						QSA_DebugArray.spellIgnored[mob][effect] = true;
					end
				end
			end


			return;
		end

		for effect, mob in string.gfind(arg1,QSA_FormatGlobalStrings(AURAREMOVEDOTHER)) do
			QSA_Fade(mob, effect);
			return;
		end

		for mob, effect in string.gfind(arg1,QSA_FormatGlobalStrings(AURADISPELOTHER)) do
			QSA_Fade(mob, effect);
			return;
		end

		for mob, effect in string.gfind(arg1,QSA_FormatGlobalStrings(AURAADDEDOTHERHELPFUL)) do
			QSA_Gain(mob, effect);
			return;
		end

		-- GAIN2 is for when a mob gets a bad status ailment...
		-- we don't normally care about that... so only do it
		-- if it is an important event.
		for mob, effect in string.gfind(arg1,QSA_FormatGlobalStrings(AURAADDEDOTHERHARMFUL)) do
			if (QSA_ImportantEffects[effect]) then
				QSA_Gain(mob, effect);
			else
				if (QSA_Debug) then
					if (not QSA_IsInParty(mob)) then
						if ( not QSA_DebugArray.gainAffliction) then
							QSA_DebugArray.gainAffliction = { };
						end
						if ( not QSA_DebugArray.gainAffliction[mob]) then
							QSA_DebugArray.gainAffliction[mob] = { };
						end
						QSA_DebugArray.gainAffliction[mob][effect] = true;
					end
				end

			end
			return;
		end

		---------------------------------------------------------------------------
		-- final debug section... this is all the stuff that was uncought
		---------------------------------------------------------------------------
		if (QSA_Debug) then

			-- this was not cought, consumed, or displayed
			if ( not QSA_DebugArray.uncought) then
				QSA_DebugArray.uncought = { };
			end
			QSA_DebugArray.uncought[arg1] = event;
		end
	end
end

