if ( GetLocale() == "deDE_DISABLED" ) then
-------------------------------------------------------------------------------
-- German localization
-------------------------------------------------------------------------------
elseif ( GetLocale() == "frFR_DISABLED" ) then
-------------------------------------------------------------------------------
-- French localization
-------------------------------------------------------------------------------
else
-------------------------------------------------------------------------------
-- English localization (Default)
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
--User Interface Strings
-------------------------------------------------------------------------------
BINDING_NAME_QSATARGET  = "Target Last Caster";
QSA_TOTEM    = "Totem";

QSA_MACRO_STATUS = "status";
QSA_MACRO_STATUS_DESC = "This displays the current settings";
QSA_MACRO_TOGGLE = "toggle";
QSA_MACRO_TOGGLE_DESC = "This toggles Quu Spell Alert on and off";
QSA_MACRO_REPORT = "report";
QSA_MACRO_REPORT_DESC = "This reports important events into party/raid";
QSA_MACRO_TARGET = "target";
QSA_MACRO_TARGET_DESC = "This will attempt to target the last name displayed";
QSA_MACRO_SHOW   = "show";
QSA_MACRO_SHOW_DESC = "This shows the anchor";
QSA_MACRO_EMOTE  = "emote";
QSA_MACRO_EMOTE_DESC = "This toggles the displaying of emotes";
QSA_MACRO_GAIN   = "gain";
QSA_MACRO_GAIN_DESC = "This toggles the displaying of 'gains'";
QSA_MACRO_FADE   = "fade";
QSA_MACRO_FADE_DESC = "This toggles the displaying of 'fades'";
QSA_MACRO_COMBAT = "combat";
QSA_MACRO_COMBAT_DESC = "This toggles the combat only mode";
QSA_MACRO_TRGNLY = "trgonly";
QSA_MACRO_TRGNLY_DESC = "This toggles the target only mode";
QSA_MACRO_TEST   = "test";
QSA_MACRO_TEST_DESC = "This shows a test message... good for moving";
QSA_MACRO_ERROR = "Unknown QSA command!";

-- maybe not translate these
QSA_MACRO_DEBUG           = "debug";
QSA_MACRO_DEBUG_DESC      = "Debug mode";
QSA_DEBUG_ENABLED         = " Debug mode enabled.";
QSA_MACRO_DEBUGCLEAR      = "debugclear";
QSA_MACRO_DEBUGCLEAR_DESC = "This clears out the debug mode data";
QSA_MACRO_DEBUGCLEAR_MSG  = "Debug data cleared!";

QSA_STATUS_ENABLED  = " Quu Spell Alert enabled.";
QSA_STATUS_DISBALED = " Quu Spell Alert disabled.";
QSA_REPORT_ENABLED  = " Reporting for group enabled.";
QSA_EMOTE_ENABLED   = " Emote mode enabled.";
QSA_GAIN_ENABLED    = " Gain mode enabled.";
QSA_FADE_ENABLED    = " Fade mode enabled.";
QSA_TARGET_ENABLED  = " Combat only mode enabled.";
QSA_TRGONLY_ENABLED = " Target only mode enabled.";

-------------------------------------------------------------------------------
-- output settings
-------------------------------------------------------------------------------
-- for all of these... $c = caster, $e = effect
QSA_CASTING_BANNER = "$e ($c)";
QSA_CASTING_REPORT = "$c casting $e";
QSA_SPELL_BANNER   = "$e ($c)";
QSA_SPELL_REPORT   = "$c cast $e";
QSA_GAIN_BANNER    = "*$e* ($c)";
QSA_GAIN_REPORT    = "$c gains $e";
QSA_FADE_BANNER    = "(-)$e(-) ($c)";
QSA_FADE_REPORT    = "$c loses $e";
QSA_EMOTE_BANNER   = "$c $e";
QSA_EMOTE_REPORT   = "$c $e";

-------------------------------------------------------------------------------
-- now for the conquest guild specific settings (adapted from sudo's code)
-- look at AURAADDEDOTHERHARMFUL in the GlobalStrings.lua for the
-- formating of afflicted by messages
-------------------------------------------------------------------------------
QSA_Geddon_String = "^(%w+) %w+ afflicted by Living Bomb";
-- $p is the player name
QSA_Geddon_Raid_Warning = "$p is the living bomb, stand clear!";
QSA_Geddon_Banner_MSG   = "You are the living bomb!";
QSA_Geddon_Delay_MSG    = "Living bomb in two seconds!";

-- i combined two of the conquest guild mods into one...
QSA_Affliction_Timers = {
	-- Gehennas from CQGehennas by sudo
	["afflicted by Gehennas"] = {
		["Banner"]    = "Gehennas has cursed",
		["Report"]    = "Gehennas has cursed, next curse in ~30 seconds",
		["Delay_MSG"] = "Next Gehennas curse in ~5 seconds",
		["Timer"]     = 25,
	},
	-- Magmadar from CQMagmadar by sudo
	["afflicted by Panic."] = {
		["Banner"]    = "Magmadar has feared",
		["Report"]    = "Magmadar has feared, next fear in ~30 seconds",
		["Delay_MSG"] = "Next Magmadar fear in ~5 seconds",
		["Timer"]     = 25,
	},
}



-------------------------------------------------------------------------------
-- the logic arrays... ignored effects and important effects
-------------------------------------------------------------------------------
QSA_IgnoreSpells = {
}
QSA_ImportantSpells = {
	["Fear"] = true,
	["Silence"] = true,
	["Dominate Mind"] = true,
}

QSA_IgnoreSpells = {
	["Stoneclaw Totem"] = true, -- um... a player would not care about a taunt totem
}
QSA_ImportantSpells = {
}

QSA_IgnoreEffects = {
	["Taunt"] = true,
}
QSA_ImportantEffects = {
	-- these two last 10 seconds when done in molten core
	-- what are the names of the adds with majordomo??? and does majordomo do an effect or emote?
	-- these also have a 30 second recast... need to find the names of what does them
	-- these are from the CQMajorDomo by Sudo
	["Magic Reflection"] = true,
	["Damage Shield"] = true,
	-- rest of the stuff
	["Will of the Forsaken"] = true,
	["Berserker Rage"] = true,
	["Frenzy"] = true, -- magnamar
	["Stoneform"] = true,
	["Bone Armor"] = true, -- from scholomance
}

QSA_IgnoreEmotes = {
	["attempts to run away in fear!"] = true, -- i hate the run away messages
	["grumbles."] = true, -- Worosh in LBRS
	["cries."] = true, -- Worosh in LBRS
	["cries for help."] = true, -- Awbee in UBRS
}
QSA_ImportantEmotes = {
	["takes in a deep breath..."] = true, -- Onyxia's big attack... from CQOnyxia mod by sudo
	["goes into a killing frenzy!"] = true, -- Magmadar frenzy ability from CQMagmadar from sudo
}

end
