

-- Configuration variables
local UUI_PROPS_ENABLE	= 1;	-- set this to non nil to enable props
local ThisRealmName = GetCVar("realmName");

if( ThisRealmName == "Arthas" ) then
	PropsCoderTooltips = {
		["Dakkon"] = "Ultimate UI Mastermind";
		["Dakken"] = "Mage Headmaster";
		["Zris"] = "Ascendant Evincar";
	};
elseif( ThisRealmName == "Lightning's Blade" ) then
	PropsCoderTooltips = {
		["Dakkan"] = "Descendant Taskmaster";
		["Zeeg"] = "zeeg will pwn j00!!!";
	};
elseif( ThisRealmName == "Nathrezim" ) then
	PropsCoderTooltips = {
		["Dakkan"] = "Deathstalker Overlord";
		["Scatercraft"] = "Warning: Ninja Looter DO NOT GROUP WITH.";
		["Arch"] = "Creator of Ultimate UI";
		["Exodius"] = "Elite Horde Champion";
		["Archen"] = "Mage Headmaster";
	};
elseif( ThisRealmName == "Mal'Ganis" ) then
	PropsCoderTooltips = {
		["Zariz"] = "Rogues do it from Behind";
	};
elseif( ThisRealmName == "Medivh" ) then
	PropsCoderTooltips = {
		["Wizbang"] = "Devious Degenerate, Defender of the Devil";
	};
elseif( ThisRealmName == "Destromath" ) then
	PropsCoderTooltips = {
		["Alliyah"] = "High Priestess of the Alliance";
		["Brix"] = "Queen of Stealth";
	};
elseif( ThisRealmName == "Khaz'goroth" ) then
	PropsCoderTooltips = {
		["Nightslayer"] = "Member of the Demonhunters";
	};
else
		PropsCoderTooltips = { };
end

PropsTooltips = { };

-- Callback functions
function TooltipsPropsTarget_Enable(toggle)
	if(toggle == 1) then 
		UUI_PROPS_ENABLE = 1;
	else
		UUI_PROPS_ENABLE = nil;
	end
end


function TooltipsPropsTarget_ModifyTooltip(type)
		local name = GameTooltipTextLeft1:GetText();
		if (name) then
			local oldTip = GameTooltipTextLeft2:GetText();
			if (oldTip) then
				local coder = PropsCoderTooltips[name];
				if (coder) then
					--GameTooltipTextLeft2:SetText(oldTip..coder);
					GameTooltip:AddLine(coder,1.0,1.0,1.0);
					--GameTooltipTextLeft3:SetText(coder);
				end
			end

		-- Sets your own notes
			local note = PropsTooltips[name];
			-- check for all lower case
			if (note == nil) then
				note = PropsTooltips[string.lower(name)];
			end
			if (note) then 
				GameTooltip:AddLine(note,1.0,1.0,1.0);
			end
		end
end


-- OnFoo functions

function TooltipsPropsTarget_OnLoad()
	--Print("SocialSendMessage_OnLoad.");

	-- Register with the UltimateUIMaster
	if(UltimateUI_RegisterConfiguration ~= nil) then
		UltimateUI_RegisterConfiguration(
			"UUI_TOOLTIPSBASE",
			"SECTION",
			TOOLTIPSBASE_SEP,
			TOOLTIPSBASE_SEP_INFO
			);
		UltimateUI_RegisterConfiguration(
			"UUI_TOOLTIPSBASE_SEP",
			"SEPARATOR",
			TOOLTIPSBASE_SEP,
			TOOLTIPSBASE_SEP_INFO
			);

		UltimateUI_RegisterConfiguration(
			"UUI_PROPS_ENABLE",	--CVar
			"CHECKBOX",						--Things to use
			TEXT(UUI_PROPS_ENABLE_TEXT),
			TEXT(UUI_PROPS_INFO),
			TooltipsPropsTarget_Enable,		--Callback
			1							--Default Checked/Unchecked
			);
		UltimateUI_RegisterChatCommand(
			"PropsAdder",
			{"/label"},
			TooltipsPropsTarget_ChatCommandHandler,
			"Adds a custom title to a player's tooltip. Usage: /label PlayerName Their Title"
			);
	end
	Sea.util.hook("TooltipsBase_UnitHandler","TooltipsPropsTarget_ModifyTooltip","after");
end

function TooltipsPropsTarget_ChatCommandHandler (msg)
	name = string.gsub (msg, "([%w]+)[ ]?(.*)", "%1");
	title = string.gsub (msg, "([%w]+)[ ]?(.*)", "%2");

	if ( name ~= "" ) then 
		if ( title == "" ) then 
			title = nil;
		end
		PropsTooltips[name] = title;
	end
end
