--[[
	XUI_Flex.lua
	XUIVersion++2004.11.14++
	
	Functions for the flex interface options add-on. 
]]
-- ** DEFAULT SETTINGS ** --
-- slider for shade, scale, alpha, gap
XUI_DefaultSliderMin = 1;
XUI_DefaultSliderStep = 1;
XUI_DefaultSliderMax = 10;
-- width by height slider settings
XUI_DefaultSlider1Min = 1;
XUI_DefaultSlider1Step = 1;
XUI_DefaultSlider1Max = 24;
-- group slider settings
XUI_DefaultSlider2Min = 1;
XUI_DefaultSlider2Step = 1;
XUI_DefaultSlider2Max = 8;
-- position slider settings
XUI_DefaultSlider3Min = 1;
XUI_DefaultSlider3Step = 1;
XUI_DefaultSlider3Max = 3;
-- anchor slider settings
XUI_DefaultSlider4Min = 1;
XUI_DefaultSlider4Step = 1;
XUI_DefaultSlider4Max = 10;
-- default setting for groups
XUI_DefaultFlexTotalGroups = 1;
XUI_DefaultFlexRed = 10;
XUI_DefaultFlexGreen = 10;
XUI_DefaultFlexBlue = 10;
XUI_DefaultFlexAlpha = 10;
XUI_DefaultFlexButtonGap = 1;
XUI_DefaultFlexToggleGrid = 0;
XUI_DefaultFlexToggleDrag = 0;
XUI_DefaultFlexToggleIcon = 0;
XUI_DefaultFlexToggleText = 0;
-- new
XUI_DefaultFlexToggleKey = 0;
XUI_DefaultFlexToggleCool = 0;
XUI_DefaultFlexToggleVerbose = 0;
XUI_DefaultFlexToggleToolTip = 0;

-- ** GENERAL VARIABLES ** --
-- General binding header and lag meter labels
BINDING_HEADER_XUIFLEXHEADER = "XUIMod Flex";
-- MASTER Initial setup of slider settings
XUI_SliderMin = XUI_DefaultSliderMin;
XUI_SliderStep = XUI_DefaultSliderStep;
XUI_SliderMax = XUI_DefaultSliderMax;
-- GROUPS Initial setup of slider settings
XUI_Slider1Min = XUI_DefaultSlider1Min;
XUI_Slider1Step = XUI_DefaultSlider1Step;
XUI_Slider1Max = XUI_DefaultSlider1Max;
-- TOTAL GROUPS Initial setup of slider settings
XUI_Slider2Min = XUI_DefaultSlider2Min;
XUI_Slider2Step = XUI_DefaultSlider2Step;
XUI_Slider2Max = XUI_DefaultSlider2Max;
-- Groups Position Initial setup of slider settings
XUI_Slider3Min = XUI_DefaultSlider3Min;
XUI_Slider3Step = XUI_DefaultSlider3Step;
XUI_Slider3Max = XUI_DefaultSlider3Max;
-- Groups Anchor Initial setup of slider settings
XUI_Slider4Min = XUI_DefaultSlider4Min;
XUI_Slider4Step = XUI_DefaultSlider4Step;
XUI_Slider4Max = XUI_DefaultSlider4Max;

-- temp variables for currently on setting in loops
setglobal("myXX", 0);
setglobal("myYY", 0);
setglobal("groupend", 0);
setglobal("groupstart", 0);
setglobal("grouppos", 0);
setglobal("groupanchor", 0);
setglobal("groupwidth", 0);
setglobal("groupheight", 0);
-- temp variables for currently on setting in loops
setglobal("groupend2", 0);
setglobal("groupstart2", 0);
setglobal("grouppos2", 0);
setglobal("groupanchor2", 0);
setglobal("groupwidth2", 0);
setglobal("groupheight2", 0);

-- per group settings for 8 groups of buttons
for i=1,XUI_Slider2Max do 
setglobal("XUI_DefaultFlexWidth"..i, 12);
setglobal("XUI_DefaultFlexHeight"..i, 1);
setglobal("XUI_DefaultFlexScale"..i, 10);
setglobal("XUI_DefaultFlexPos"..i, 2);
end
setglobal("XUI_DefaultFlexAnchor1", 9);
local t;
t=0;
for i=2,XUI_Slider2Max do 
setglobal("XUI_DefaultFlexAnchor"..i, t+1);
t=t+1;
end

-- ** GENERAL OPTIONS FUNCTIONS ** --
-- Setup variable loading for general options without a frame
function XUI_FlexLoadsOnLoad ()
	this:RegisterEvent("VARIABLES_LOADED");
end

function XUI_FlexLoadsOnEvent ()
	if ( event == "VARIABLES_LOADED" ) then
		--Total Groups
		if (XUI_RetrieveSaved("TotalGroups") == nil) then
			XUI_FlexTotalGroups = XUI_DefaultFlexTotalGroups;
		else
			XUI_FlexTotalGroups = XUI_RetrieveSaved("TotalGroups");
		end
		--Red
		if (XUI_RetrieveSaved("RedShading") == nil) then
			XUI_FlexRed = XUI_DefaultFlexRed;
		else
			XUI_FlexRed = XUI_RetrieveSaved("RedShading");
		end
		--Green
		if (XUI_RetrieveSaved("GreenShading") == nil) then
			XUI_FlexGreen = XUI_DefaultFlexGreen;
		else
			XUI_FlexGreen = XUI_RetrieveSaved("GreenShading");
		end
		--Blue
		if (XUI_RetrieveSaved("BlueShading") == nil) then
			XUI_FlexBlue = XUI_DefaultFlexBlue;
		else
			XUI_FlexBlue = XUI_RetrieveSaved("BlueShading");
		end
		--Alpha
		if (XUI_RetrieveSaved("AlphaShading") == nil) then
			XUI_FlexAlpha = XUI_DefaultFlexAlpha;
		else
			XUI_FlexAlpha = XUI_RetrieveSaved("AlphaShading");
		end
		--ButtonGap
		if (XUI_RetrieveSaved("ButtonGap") == nil) then
			XUI_FlexButtonGap = XUI_DefaultFlexButtonGap;
		else
			XUI_FlexButtonGap = XUI_RetrieveSaved("ButtonGap");
		end
		--ToggleGrid
		if (XUI_RetrieveSaved("ToggleGrid") == nil) then
			XUI_FlexToggleGrid = XUI_DefaultFlexToggleGrid;
		else
			XUI_FlexToggleGrid = XUI_RetrieveSaved("ToggleGrid");
		end
		--ToggleDrag
		if (XUI_RetrieveSaved("ToggleDrag") == nil) then
			XUI_FlexToggleDrag = XUI_DefaultFlexToggleDrag;
		else
			XUI_FlexToggleDrag = XUI_RetrieveSaved("ToggleDrag");
		end
		--ToggleIcon
		if (XUI_RetrieveSaved("ToggleIcon") == nil) then
			XUI_FlexToggleIcon = XUI_DefaultFlexToggleIcon;
		else
			XUI_FlexToggleIcon = XUI_RetrieveSaved("ToggleIcon");
		end
		--ToggleText button
		if (XUI_RetrieveSaved("ToggleText") == nil) then
			XUI_FlexToggleText = XUI_DefaultFlexToggleText;
		else
			XUI_FlexToggleText = XUI_RetrieveSaved("ToggleText");
		end
		--ToggleText hotkey
		if (XUI_RetrieveSaved("ToggleKey") == nil) then
			XUI_FlexToggleKey = XUI_DefaultFlexToggleKey;
		else
			XUI_FlexToggleKey = XUI_RetrieveSaved("ToggleKey");
		end
		--ToggleText cooldown
		if (XUI_RetrieveSaved("ToggleCool") == nil) then
			XUI_FlexToggleCool = XUI_DefaultFlexToggleCool;
		else
			XUI_FlexToggleCool = XUI_RetrieveSaved("ToggleCool");
		end
		--ToggleVerbose
		if (XUI_RetrieveSaved("ToggleVerbose") == nil) then
			XUI_FlexToggleVerbose = XUI_DefaultFlexToggleVerbose;
		else
			XUI_FlexToggleVerbose = XUI_RetrieveSaved("ToggleVerbose");
		end
		--ToggleToolTip
		if (XUI_RetrieveSaved("ToggleToolTip") == nil) then
			XUI_FlexToggleToolTip = XUI_DefaultFlexToggleToolTip;
		else
			XUI_FlexToggleToolTip = XUI_RetrieveSaved("ToggleToolTip");
		end
		--Total Groups
		if (XUI_RetrieveSaved("TotalGroups") == nil) then
			XUI_FlexTotalGroups = XUI_DefaultFlexTotalGroups;
		else
			XUI_FlexTotalGroups = XUI_RetrieveSaved("TotalGroups");
		end
		--Width1
		if (XUI_RetrieveSaved("Width1") == nil) then
			XUI_FlexWidth1 = XUI_DefaultFlexWidth1;
		else
			XUI_FlexWidth1 = XUI_RetrieveSaved("Width1");
		end
		--Height1
		if (XUI_RetrieveSaved("Height1") == nil) then
			XUI_FlexHeight1 = XUI_DefaultFlexHeight1;
		else
			XUI_FlexHeight1 = XUI_RetrieveSaved("Height1");
		end
		--Scale1
		if (XUI_RetrieveSaved("Scale1") == nil) then
			XUI_FlexScale1 = XUI_DefaultFlexScale1;
		else
			XUI_FlexScale1 = XUI_RetrieveSaved("Scale1");
		end
		--Pos1
		if (XUI_RetrieveSaved("Pos1") == nil) then
			XUI_FlexPos1 = XUI_DefaultFlexPos1;
		else
			XUI_FlexPos1 = XUI_RetrieveSaved("Pos1");
		end
		--Anchor1
		if (XUI_RetrieveSaved("Anchor1") == nil) then
			XUI_FlexAnchor1 = XUI_DefaultFlexAnchor1;
		else
			XUI_FlexAnchor1 = XUI_RetrieveSaved("Anchor1");
		end
		--Width2
		if (XUI_RetrieveSaved("Width2") == nil) then
			XUI_FlexWidth2 = XUI_DefaultFlexWidth2;
		else
			XUI_FlexWidth2 = XUI_RetrieveSaved("Width2");
		end
		--Height2
		if (XUI_RetrieveSaved("Height2") == nil) then
			XUI_FlexHeight2 = XUI_DefaultFlexHeight2;
		else
			XUI_FlexHeight2 = XUI_RetrieveSaved("Height2");
		end
		--Scale2
		if (XUI_RetrieveSaved("Scale2") == nil) then
			XUI_FlexScale2 = XUI_DefaultFlexScale2;
		else
			XUI_FlexScale2 = XUI_RetrieveSaved("Scale2");
		end
		--Pos2
		if (XUI_RetrieveSaved("Pos2") == nil) then
			XUI_FlexPos2 = XUI_DefaultFlexPos2;
		else
			XUI_FlexPos2 = XUI_RetrieveSaved("Pos2");
		end
		--Anchor2
		if (XUI_RetrieveSaved("Anchor2") == nil) then
			XUI_FlexAnchor2 = XUI_DefaultFlexAnchor2;
		else
			XUI_FlexAnchor2 = XUI_RetrieveSaved("Anchor2");
		end
		--Width3
		if (XUI_RetrieveSaved("Width3") == nil) then
			XUI_FlexWidth3 = XUI_DefaultFlexWidth3;
		else
			XUI_FlexWidth3 = XUI_RetrieveSaved("Width3");
		end
		--Height3
		if (XUI_RetrieveSaved("Height3") == nil) then
			XUI_FlexHeight3 = XUI_DefaultFlexHeight3;
		else
			XUI_FlexHeight3 = XUI_RetrieveSaved("Height3");
		end
		--Scale3
		if (XUI_RetrieveSaved("Scale3") == nil) then
			XUI_FlexScale3 = XUI_DefaultFlexScale3;
		else
			XUI_FlexScale3 = XUI_RetrieveSaved("Scale3");
		end
		--Pos3
		if (XUI_RetrieveSaved("Pos3") == nil) then
			XUI_FlexPos3 = XUI_DefaultFlexPos3;
		else
			XUI_FlexPos3 = XUI_RetrieveSaved("Pos3");
		end
		--Anchor3
		if (XUI_RetrieveSaved("Anchor3") == nil) then
			XUI_FlexAnchor3 = XUI_DefaultFlexAnchor3;
		else
			XUI_FlexAnchor3 = XUI_RetrieveSaved("Anchor3");
		end
		--Width4
		if (XUI_RetrieveSaved("Width4") == nil) then
			XUI_FlexWidth4 = XUI_DefaultFlexWidth4;
		else
			XUI_FlexWidth4 = XUI_RetrieveSaved("Width4");
		end
		--Height4
		if (XUI_RetrieveSaved("Height4") == nil) then
			XUI_FlexHeight4 = XUI_DefaultFlexHeight4;
		else
			XUI_FlexHeight4 = XUI_RetrieveSaved("Height4");
		end
		--Scale4
		if (XUI_RetrieveSaved("Scale4") == nil) then
			XUI_FlexScale4 = XUI_DefaultFlexScale4;
		else
			XUI_FlexScale4 = XUI_RetrieveSaved("Scale4");
		end
		--Pos4
		if (XUI_RetrieveSaved("Pos4") == nil) then
			XUI_FlexPos4 = XUI_DefaultFlexPos4;
		else
			XUI_FlexPos4 = XUI_RetrieveSaved("Pos4");
		end
		--Anchor4
		if (XUI_RetrieveSaved("Anchor4") == nil) then
			XUI_FlexAnchor4 = XUI_DefaultFlexAnchor4;
		else
			XUI_FlexAnchor4 = XUI_RetrieveSaved("Anchor4");
		end
		--Width5
		if (XUI_RetrieveSaved("Width5") == nil) then
			XUI_FlexWidth5 = XUI_DefaultFlexWidth5;
		else
			XUI_FlexWidth5 = XUI_RetrieveSaved("Width5");
		end
		--Height5
		if (XUI_RetrieveSaved("Height5") == nil) then
			XUI_FlexHeight5 = XUI_DefaultFlexHeight5;
		else
			XUI_FlexHeight5 = XUI_RetrieveSaved("Height5");
		end
		--Scale5
		if (XUI_RetrieveSaved("Scale5") == nil) then
			XUI_FlexScale5 = XUI_DefaultFlexScale5;
		else
			XUI_FlexScale5 = XUI_RetrieveSaved("Scale5");
		end
		--Pos5
		if (XUI_RetrieveSaved("Pos5") == nil) then
			XUI_FlexPos5 = XUI_DefaultFlexPos5;
		else
			XUI_FlexPos5 = XUI_RetrieveSaved("Pos5");
		end
		--Anchor5
		if (XUI_RetrieveSaved("Anchor5") == nil) then
			XUI_FlexAnchor5 = XUI_DefaultFlexAnchor5;
		else
			XUI_FlexAnchor5 = XUI_RetrieveSaved("Anchor5");
		end
		--Width6
		if (XUI_RetrieveSaved("Width6") == nil) then
			XUI_FlexWidth6 = XUI_DefaultFlexWidth6;
		else
			XUI_FlexWidth6 = XUI_RetrieveSaved("Width6");
		end
		--Height6
		if (XUI_RetrieveSaved("Height6") == nil) then
			XUI_FlexHeight6 = XUI_DefaultFlexHeight6;
		else
			XUI_FlexHeight6 = XUI_RetrieveSaved("Height6");
		end
		--Scale6
		if (XUI_RetrieveSaved("Scale6") == nil) then
			XUI_FlexScale6 = XUI_DefaultFlexScale6;
		else
			XUI_FlexScale6 = XUI_RetrieveSaved("Scale6");
		end
		--Pos6
		if (XUI_RetrieveSaved("Pos6") == nil) then
			XUI_FlexPos6 = XUI_DefaultFlexPos6;
		else
			XUI_FlexPos6 = XUI_RetrieveSaved("Pos6");
		end
		--Anchor6
		if (XUI_RetrieveSaved("Anchor6") == nil) then
			XUI_FlexAnchor6 = XUI_DefaultFlexAnchor6;
		else
			XUI_FlexAnchor6 = XUI_RetrieveSaved("Anchor6");
		end
		--Width7
		if (XUI_RetrieveSaved("Width7") == nil) then
			XUI_FlexWidth7 = XUI_DefaultFlexWidth7;
		else
			XUI_FlexWidth7 = XUI_RetrieveSaved("Width7");
		end
		--Height7
		if (XUI_RetrieveSaved("Height7") == nil) then
			XUI_FlexHeight7 = XUI_DefaultFlexHeight7;
		else
			XUI_FlexHeight7 = XUI_RetrieveSaved("Height7");
		end
		--Scale7
		if (XUI_RetrieveSaved("Scale7") == nil) then
			XUI_FlexScale7 = XUI_DefaultFlexScale7;
		else
			XUI_FlexScale7 = XUI_RetrieveSaved("Scale7");
		end
		--Pos7
		if (XUI_RetrieveSaved("Pos7") == nil) then
			XUI_FlexPos7 = XUI_DefaultFlexPos7;
		else
			XUI_FlexPos7 = XUI_RetrieveSaved("Pos7");
		end
		--Anchor7
		if (XUI_RetrieveSaved("Anchor7") == nil) then
			XUI_FlexAnchor7 = XUI_DefaultFlexAnchor7;
		else
			XUI_FlexAnchor7 = XUI_RetrieveSaved("Anchor7");
		end
		--Width8
		if (XUI_RetrieveSaved("Width8") == nil) then
			XUI_FlexWidth8 = XUI_DefaultFlexWidth8;
		else
			XUI_FlexWidth8 = XUI_RetrieveSaved("Width8");
		end
		--Height8
		if (XUI_RetrieveSaved("Height8") == nil) then
			XUI_FlexHeight8 = XUI_DefaultFlexHeight8;
		else
			XUI_FlexHeight8 = XUI_RetrieveSaved("Height8");
		end
		--Scale8
		if (XUI_RetrieveSaved("Scale8") == nil) then
			XUI_FlexScale8 = XUI_DefaultFlexScale8;
		else
			XUI_FlexScale8 = XUI_RetrieveSaved("Scale8");
		end
		--Pos8
		if (XUI_RetrieveSaved("Pos8") == nil) then
			XUI_FlexPos8 = XUI_DefaultFlexPos8;
		else
			XUI_FlexPos8 = XUI_RetrieveSaved("Pos8");
		end
		--Anchor8
		if (XUI_RetrieveSaved("Anchor8") == nil) then
			XUI_FlexAnchor8 = XUI_DefaultFlexAnchor8;
		else
			XUI_FlexAnchor8 = XUI_RetrieveSaved("Anchor8");
		end
		XUI_RegisterOption(150, "category", nil, nil, nil, "Flex", "Flexbar Configuration");
		XUI_RegisterOption(254, "slider", XUI_FlexRed, "RedShading", XUI_FlexUpdate,"Red Shading", "Red channel Shading", XUI_SliderMin, XUI_SliderMax, XUI_SliderStep, " ");
		XUI_RegisterOption(255, "slider", XUI_FlexGreen, "GreenShading", XUI_FlexUpdate,"Green Shading", "Green channel Shading", XUI_SliderMin, XUI_SliderMax, XUI_SliderStep, " ");
		XUI_RegisterOption(256, "slider", XUI_FlexBlue, "BlueShading", XUI_FlexUpdate,"Blue Shading", "Blue channel shading", XUI_SliderMin, XUI_SliderMax, XUI_SliderStep, " ");
		XUI_RegisterOption(257, "slider", XUI_FlexAlpha, "AlphaShading", XUI_FlexUpdate,"Transparency", "Transparency", XUI_SliderMin, XUI_SliderMax, XUI_SliderStep, " ");
		XUI_RegisterOption(258, "button", nil, nil, XUI_FlexApply, "Apply", "Click to apply settings.\nIf everything does not get moved,\nclick the button again");
		XUI_RegisterOption(259, "check", XUI_FlexToggleGrid, "ToggleGrid", XUI_FlexUpdate, "Hide Grid", "Hide the button grid.\nThe grid is the button placeholders");
		XUI_RegisterOption(260, "check", XUI_FlexToggleDrag, "ToggleDrag", XUI_FlexUpdate, "Hide Anchor", "Hide the groups dragable anchor.");
		XUI_RegisterOption(261, "slider", XUI_FlexTotalGroups, "TotalGroups", XUI_FlexUpdate,"TotalGroups", "Total Number of Flexbar Groups", XUI_Slider2Min, XUI_Slider2Max, XUI_Slider2Step, " ");
		XUI_RegisterOption(263, "button", nil, nil, XUI_FlexReset, "Reset", "Click to reset all flexbar settings.");
		XUI_RegisterOption(267, "button", nil, nil, XUI_FlexDefault, "Default", "Click to reset shading to Blizzard Default.\nThis option was added to see the shadding\nwhen mana, rage, energy is not enough for the skill.");
		XUI_RegisterOption(264, "check", XUI_FlexToggleIcon, "ToggleIcon", XUI_FlexUpdate, "Lock Icon", "Lock Icons so only holding shift can move them.");
		XUI_RegisterOption(265, "slider", XUI_FlexButtonGap, "ButtonGap", XUI_FlexUpdate,"Button Gap", "The gap between Buttons.", XUI_SliderMin, XUI_SliderMax, XUI_SliderStep, " ");
		XUI_RegisterOption(266, "check", XUI_FlexToggleText, "ToggleText", XUI_FlexUpdate, "Show Numbers", "Show the button numbers on buttons.");
		XUI_RegisterOption(268, "check", XUI_FlexToggleKey, "ToggleKey", XUI_FlexUpdate, "Show HotKeys", "Show the HotKey labels on buttons.");
		XUI_RegisterOption(269, "check", XUI_FlexToggleCool, "ToggleCool", XUI_FlexUpdate, "Show Cooldown", "Show the cooldown labels on buttons.");
		XUI_RegisterOption(270, "check", XUI_FlexToggleVerbose, "ToggleVerbose", XUI_FlexUpdate, "Toggle Verbose", "Toggle displaying verbose messages.\nFlexbar confirmation messages on commands");
		XUI_RegisterOption(271, "check", XUI_FlexToggleToolTip, "ToggleToolTip", XUI_FlexUpdate, "Hide ToolTips", "Hide Tooltip on Flexbar buttons.");
		-- group tab
		XUI_RegisterOption(200, "category", nil, nil, nil, "Groups", "Flexbar Groups");
		XUI_RegisterOption(301, "slider", XUI_FlexWidth1, "Width1", XUI_FlexUpdate,"Width", "Group1 number of columns\nThe number of buttons horizontally", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(302, "slider", XUI_FlexHeight1, "Height1", XUI_FlexUpdate,"Height", "Group1 number of rows\nThe number of buttons vertically", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(303, "slider", XUI_FlexScale1, "Scale1", XUI_FlexUpdate,"Scale", "Group1 buttons scale\nThe size of the buttons", XUI_SliderMin+4, XUI_SliderMax+4, XUI_SliderStep, " ");
		XUI_RegisterOption(304, "slider", XUI_FlexWidth2, "Width2", XUI_FlexUpdate,"Width", "Group2 number of columns\nThe number of buttons horizontally", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(305, "slider", XUI_FlexHeight2, "Height2", XUI_FlexUpdate,"Height", "Group2 number of rows\nThe number of buttons vertically", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(306, "slider", XUI_FlexScale2, "Scale2", XUI_FlexUpdate,"Scale", "Group2 buttons scale\nThe size of the buttons", XUI_SliderMin+4, XUI_SliderMax+4, XUI_SliderStep, " ");
		XUI_RegisterOption(307, "slider", XUI_FlexWidth3, "Width3", XUI_FlexUpdate,"Width", "Group3 number of columns\nThe number of buttons horizontally", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(308, "slider", XUI_FlexHeight3, "Height3", XUI_FlexUpdate,"Height", "Group3 number of rows\nThe number of buttons vertically", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(309, "slider", XUI_FlexScale3, "Scale3", XUI_FlexUpdate,"Scale", "Group3 buttons scale\nThe size of the buttons", XUI_SliderMin+4, XUI_SliderMax+4, XUI_SliderStep, " ");
		XUI_RegisterOption(310, "slider", XUI_FlexWidth4, "Width4", XUI_FlexUpdate,"Width", "Group4 number of columns\nThe number of buttons horizontally", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(311, "slider", XUI_FlexHeight4, "Height4", XUI_FlexUpdate,"Height", "Group4 number of rows\nThe number of buttons vertically", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(312, "slider", XUI_FlexScale4, "Scale4", XUI_FlexUpdate,"Scale", "Group4 buttons scale\nThe size of the buttons", XUI_SliderMin+4, XUI_SliderMax+4, XUI_SliderStep, " ");
		XUI_RegisterOption(313, "slider", XUI_FlexWidth5, "Width5", XUI_FlexUpdate,"Width", "Group5 number of columns\nThe number of buttons horizontally", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(314, "slider", XUI_FlexHeight5, "Height5", XUI_FlexUpdate,"Height", "Group5 number of rows\nThe number of buttons vertically", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(315, "slider", XUI_FlexScale5, "Scale6", XUI_FlexUpdate,"Scale", "Group5 buttons scale\nThe size of the buttons", XUI_SliderMin+4, XUI_SliderMax+4, XUI_SliderStep, " ");
		XUI_RegisterOption(316, "slider", XUI_FlexWidth6, "Width6", XUI_FlexUpdate,"Width", "Group6 number of columns\nThe number of buttons horizontally", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(317, "slider", XUI_FlexHeight6, "Height6", XUI_FlexUpdate,"Height", "Group6 number of rows\nThe number of buttons vertically", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(318, "slider", XUI_FlexScale6, "Scale7", XUI_FlexUpdate,"Scale", "Group6 buttons scale\nThe size of the buttons", XUI_SliderMin+4, XUI_SliderMax+4, XUI_SliderStep, " ");
		XUI_RegisterOption(319, "slider", XUI_FlexWidth7, "Width7", XUI_FlexUpdate,"Width", "Group7 number of columns\nThe number of buttons horizontally", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(320, "slider", XUI_FlexHeight7, "Height7", XUI_FlexUpdate,"Height", "Group7 number of rows\nThe number of buttons vertically", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(321, "slider", XUI_FlexScale7, "Scale7", XUI_FlexUpdate,"Scale", "Group7 buttons scale\nThe size of the buttons", XUI_SliderMin+4, XUI_SliderMax+4, XUI_SliderStep, " ");
		XUI_RegisterOption(322, "slider", XUI_FlexWidth8, "Width8", XUI_FlexUpdate,"Width", "Group8 number of columns\nThe number of buttons horizontally", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(323, "slider", XUI_FlexHeight8, "Height8", XUI_FlexUpdate,"Height", "Group8 number of rows\nThe number of buttons vertically", XUI_Slider1Min, XUI_Slider1Max, XUI_Slider1Step, " ");
		XUI_RegisterOption(324, "slider", XUI_FlexScale8, "Scale8", XUI_FlexUpdate,"Scale", "Group8 buttons scale\nThe size of the buttons", XUI_SliderMin+4, XUI_SliderMax+4, XUI_SliderStep, " ");
		XUI_RegisterOption(325, "slider", XUI_FlexPos1, "Pos1", XUI_FlexUpdate,"Position", "Group1 Position\nPosition of the slider indicates\nthe position to achor off", XUI_Slider3Min, XUI_Slider3Max, XUI_Slider3Step, " ");
		XUI_RegisterOption(326, "slider", XUI_FlexPos2, "Pos2", XUI_FlexUpdate,"Position", "Group2 Position\nPosition of the slider indicates\nthe position to achor off", XUI_Slider3Min, XUI_Slider3Max, XUI_Slider3Step, " ");
		XUI_RegisterOption(327, "slider", XUI_FlexPos3, "Pos3", XUI_FlexUpdate,"Position", "Group3 Position\nPosition of the slider indicates\nthe position to achor off", XUI_Slider3Min, XUI_Slider3Max, XUI_Slider3Step, " ");
		XUI_RegisterOption(328, "slider", XUI_FlexPos4, "Pos4", XUI_FlexUpdate,"Position", "Group4 Position\nPosition of the slider indicates\nthe position to achor off", XUI_Slider3Min, XUI_Slider3Max, XUI_Slider3Step, " ");
		XUI_RegisterOption(329, "slider", XUI_FlexPos5, "Pos5", XUI_FlexUpdate,"Position", "Group5 Position\nPosition of the slider indicates\nthe position to achor off", XUI_Slider3Min, XUI_Slider3Max, XUI_Slider3Step, " ");
		XUI_RegisterOption(330, "slider", XUI_FlexPos6, "Pos6", XUI_FlexUpdate,"Position", "Group6 Position\nPosition of the slider indicates\nthe position to achor off", XUI_Slider3Min, XUI_Slider3Max, XUI_Slider3Step, " ");
		XUI_RegisterOption(331, "slider", XUI_FlexPos7, "Pos7", XUI_FlexUpdate,"Position", "Group7 Position\nPosition of the slider indicates\nthe position to achor off", XUI_Slider3Min, XUI_Slider3Max, XUI_Slider3Step, " ");
		XUI_RegisterOption(332, "slider", XUI_FlexPos8, "Pos8", XUI_FlexUpdate,"Position", "Group8 Position\nPosition of the slider indicates\nthe position to achor off", XUI_Slider3Min, XUI_Slider3Max, XUI_Slider3Step, " ");
		XUI_RegisterOption(333, "slider", XUI_FlexAnchor1, "Anchor1", XUI_FlexUpdate,"Anchor", "Group1 Anchor\nNumber represent group to anchor off\n9 is the main window\n10 is Keep User Placed", XUI_Slider4Min, XUI_Slider4Max, XUI_Slider4Step, " ");
		XUI_RegisterOption(334, "slider", XUI_FlexAnchor2, "Anchor2", XUI_FlexUpdate,"Anchor", "Group2 Anchor\nNumber represent group to anchor off\n9 is the main window\n10 is Keep User Placed", XUI_Slider4Min, XUI_Slider4Max, XUI_Slider4Step, " ");
		XUI_RegisterOption(335, "slider", XUI_FlexAnchor3, "Anchor3", XUI_FlexUpdate,"Anchor", "Group3 Anchor\nNumber represent group to anchor off\n9 is the main window\n10 is Keep User Placed", XUI_Slider4Min, XUI_Slider4Max, XUI_Slider4Step, " ");
		XUI_RegisterOption(336, "slider", XUI_FlexAnchor4, "Anchor4", XUI_FlexUpdate,"Anchor", "Group4 Anchor\nNumber represent group to anchor off\n9 is the main window\n10 is Keep User Placed", XUI_Slider4Min, XUI_Slider4Max, XUI_Slider4Step, " ");
		XUI_RegisterOption(337, "slider", XUI_FlexAnchor5, "Anchor5", XUI_FlexUpdate,"Anchor", "Group5 Anchor\nNumber represent group to anchor off\n9 is the main window\n10 is Keep User Placed", XUI_Slider4Min, XUI_Slider4Max, XUI_Slider4Step, " ");
		XUI_RegisterOption(338, "slider", XUI_FlexAnchor6, "Anchor6", XUI_FlexUpdate,"Anchor", "Group6 Anchor\nNumber represent group to anchor off\n9 is the main window\n10 is Keep User Placed", XUI_Slider4Min, XUI_Slider4Max, XUI_Slider4Step, " ");
		XUI_RegisterOption(339, "slider", XUI_FlexAnchor7, "Anchor7", XUI_FlexUpdate,"Anchor", "Group7 Anchor\nNumber represent group to anchor off\n9 is the main window\n10 is Keep User Placed", XUI_Slider4Min, XUI_Slider4Max, XUI_Slider4Step, " ");
		XUI_RegisterOption(340, "slider", XUI_FlexAnchor8, "Anchor8", XUI_FlexUpdate,"Anchor", "Group8 Anchor\nNumber represent group to anchor off\n9 is the main window\n10 is Keep User Placed", XUI_Slider4Min, XUI_Slider4Max, XUI_Slider4Step, " ");
	end
end

function XUI_FlexReset()
	FB_Command_ResetAll("confirm='yes'")
end

function XUI_FlexDefault()
	FB_Command_Shade("button=1-96 color=[10 10 10] reset='true'")
end

function XUI_FlexTText()
	if (XUI_FlexToggleText==1) then
		FB_Command_Text("button=1-96 text='%d'")
	elseif (XUI_FlexToggleKey==1) then
		FB_Command_Text("button=1-96 text='%b'")
	elseif (XUI_FlexToggleCool==1) then
		FB_Command_Text("button=1-96 text='%c'")
	else
		FB_Command_Text("button=1-96 text=''")
	end
end

function XUI_FlexTVerbose()
	if XUI_FlexToggleVerbose==1 then
		FB_Command_Verbose("state='off'")
	else
		FB_Command_Verbose("state='on'")
	end
end

function XUI_FlexTToolTip()
	if XUI_FlexToggleToolTip==1 then
		FB_Command_Tooltip("state='off'")
	else
		FB_Command_Tooltip("state='on'")
	end
end

function XUI_FlexTDrag()
	if XUI_FlexToggleDrag==1 then
		FB_Command_Lock("button=1-96")
	else
		FB_Command_Unlock("button=1-96")
	end
end

function XUI_FlexTGrid()
	if XUI_FlexToggleGrid==1 then
		FB_Command_HideGrid("button=1-96")
	else
		FB_Command_ShowGrid("button=1-96")
	end
end

function XUI_FlexTIcon()
	if XUI_FlexToggleIcon==1 then
		FB_Command_LockIcon("button=1-96")
	else
		FB_Command_LockIcon("button=1-96 Off='true'")
	end
end

function XUI_FlexHelper2(gnumber2)
	groupend2=0
	groupstart2=0
	grouppos2=0
	groupanchor2=0
	groupwidth2=0
	groupheight2=0
	groupwidth2=getglobal("XUI_FlexWidth"..gnumber2);
	groupheight2=getglobal("XUI_FlexHeight"..gnumber2);
	groupanchor2=getglobal("XUI_FlexAnchor"..gnumber2);
	for n=1,gnumber2 do
		if (gnumber2==1) then
			grouppos2=getglobal("XUI_FlexPos"..n);
			groupstart2=(1+groupend2);
			groupend2=(getglobal("XUI_FlexWidth"..n)*getglobal("XUI_FlexHeight"..n));
		else
			grouppos2=getglobal("XUI_FlexPos"..n);
			groupstart2=(1+groupend2);
			groupend2=(groupstart2-1+(getglobal("XUI_FlexWidth"..n)*getglobal("XUI_FlexHeight"..n)));
		end
	end
end

function XUI_FlexHelper(gnumber)
	myXX=0
	myYY=0
	groupend=0
	groupstart=0
	grouppos=0
	groupanchor=0
	groupwidth=0
	groupheight=0
	groupwidth=getglobal("XUI_FlexWidth"..gnumber);
	groupheight=getglobal("XUI_FlexHeight"..gnumber);
	groupanchor=getglobal("XUI_FlexAnchor"..gnumber);
	for n=1,gnumber do
		if (gnumber==1) then
			grouppos=getglobal("XUI_FlexPos"..n);
			groupstart=(1+groupend);
			groupend=(getglobal("XUI_FlexWidth"..n)*getglobal("XUI_FlexHeight"..n));
		else
			grouppos=getglobal("XUI_FlexPos"..n);
			groupstart=(1+groupend);
			groupend=(groupstart-1+(getglobal("XUI_FlexWidth"..n)*getglobal("XUI_FlexHeight"..n)));
		end
	end
end

function MyMoveButtonABS(button1, x, y)
-- Moves the button and handle so the top left of the button and bottom right of the
-- frame are x pixels to the right of the bottom right corner and y pixels above it.
-- will work with either a button or handle passed to it.
	local button, frame = FB_GetWidgets(button1)
	frame:ClearAllPoints()
	local TempFlexPos
	-- set positioning strings based on sliders number
	if (grouppos == 1) then
		TempFlexPos="BOTTOMLEFT"
	elseif (grouppos == 2) then
		TempFlexPos="BOTTOM"
	else
		TempFlexPos="BOTTOMRIGHT"
	end	
	frame:SetPoint("BOTTOMRIGHT", "UIParent", TempFlexPos, x, y)
	FB_GetCoords(button1)
end

function MyVerticalGroup(group, width, padding)
-- Arranges buttons in group vertically, width columns wide with
-- the specified padding between them.
	local members = FB_GetGroupMembers(group)
	if members.n < 1 then return end
	local dim = padding + (38 * (FBState[members[1]]["scale"] or 1))
	local dimpos = padding + (36 * (FBState[members[1]]["scale"] or 1))
	local index = 1
	while index <= members.n do
		local index2
		for index2 = 1, width do
			if index <= members.n then
				if (grouppos == 1) then
					MyMoveButtonABS(members[index], 1 + padding + ((index2-1)*dim), dimpos+(floor((index-1)/width)*dim))
				elseif (grouppos == 2) then
					MyMoveButtonABS(members[index], 1 - ((groupwidth*dim)/2) + ((index2-1)*dim), dimpos+(floor((index-1)/width)*dim))
				else
					MyMoveButtonABS(members[index], 1 + padding - (groupwidth*dim) + ((index2-1)*dim), dimpos+(floor((index-1)/width)*dim))
				end
			end
			index = index+1
		end
	end
	FB_ReformGroups()
	-- reposition to anchor
	if (groupanchor == 10) then
		grouppos=1
		MyMoveButtonABS(groupstart, myXX, myYY)
	elseif (groupanchor == 9) then
		-- do nothing cause we are good
	else
		XUI_FlexHelper2(groupanchor);
		local dim2 = padding + (38 * (FBState[groupstart]["scale"] or 1))
		local dim3 = padding + (38 * (FBState[groupstart2]["scale"] or 1))
		local myXoffset
		local myYoffset
		local buttonanchor
		if (grouppos == 3) then
			buttonanchor=(groupstart2+groupwidth2-1);
			myXoffset=dim3;
			myYoffset=(dim2-dim3)
			FB_MoveButtonRel(groupstart, buttonanchor, myXoffset, myYoffset)
		elseif (grouppos == 2) then
			buttonanchor=groupstart2;
			myYoffset=((dim3*(groupheight2-1))+(dim2*(groupheight)));
			FB_MoveButtonRel(groupstart, buttonanchor, 0, myYoffset)
		else
			buttonanchor=groupstart2;
			myXoffset=(groupwidth*dim2*-1)
			myYoffset=(dim2-dim3)
			FB_MoveButtonRel(groupstart, buttonanchor, myXoffset, myYoffset)
		end
	end
end

function XUI_FlexApply()
	XUI_FlexHelper(XUI_FlexTotalGroups);
	if (groupend>96) then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<FLEX>|r This Will crash WoW your groups total is "..groupend.." keep it 96 or less");
		return;
	end
	local n
	local curButton=0
	-- ungroup
	for n=1,XUI_Slider2Max do
		XUI_FlexHelper(n);
		if (groupend<97) then
			FB_Command_Ungroup("group="..groupstart)
		else
			-- do nothing
		end
	end
	for n=1,XUI_FlexTotalGroups do
		XUI_FlexHelper(n);
		if (groupanchor == 10) then
			myXX=FBState[groupstart]["xcoord"]
			myYY=FBState[groupstart]["ycoord"]
		end
		FB_Command_Scale("button="..groupstart.."-"..groupend.." scale="..getglobal("XUI_FlexScale"..n))
		FB_Command_Group("button="..groupstart.."-"..groupend.." anchor="..groupstart)
		MyVerticalGroup(groupstart,getglobal("XUI_FlexWidth"..n),XUI_FlexButtonGap)
	end
	--end of groups now fade, shade, show
	XUI_FlexHelper(XUI_FlexTotalGroups);
	FB_Command_Fade("button=1-96 Alpha="..XUI_FlexAlpha)
	FB_Command_Shade("button=1-96 color=[ "..XUI_FlexRed.." "..XUI_FlexGreen.." "..XUI_FlexBlue.." ]")
	XUI_FlexTDrag();
	FB_Command_Hide("button=1-96")
	FB_Command_Show("button=1-"..groupend)
end

-- ** CONFIGURATION FUNCTIONS ** --
-- Update our values on sliders
function XUI_FlexUpdate (init)
	if (init == nil) then
		init = 0;
	end
	if (XUI_RetrieveOption ~= nil) then
		if (XUI_RetrieveOption(254) ~= nil) then
			XUI_FlexRed = XUI_RetrieveOption(254)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(255) ~= nil) then
			XUI_FlexGreen = XUI_RetrieveOption(255)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(256) ~= nil) then
			XUI_FlexBlue = XUI_RetrieveOption(256)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(257) ~= nil) then
			XUI_FlexAlpha = XUI_RetrieveOption(257)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(259) ~= nil) then
			if (XUI_RetrieveOption(259)[XUI_VALUE] == XUI_FlexToggleGrid) then
				XUI_FlexToggleGrid = XUI_RetrieveOption(259)[XUI_VALUE];
			else
				XUI_FlexToggleGrid = XUI_RetrieveOption(259)[XUI_VALUE];
				XUI_FlexTGrid();
			end
		end
		if (XUI_RetrieveOption(260) ~= nil) then
			if (XUI_RetrieveOption(260)[XUI_VALUE] == XUI_FlexToggleDrag) then
				XUI_FlexToggleDrag = XUI_RetrieveOption(260)[XUI_VALUE];
			else
				XUI_FlexToggleDrag = XUI_RetrieveOption(260)[XUI_VALUE];
				XUI_FlexTDrag();
			end
		end
		if (XUI_RetrieveOption(261) ~= nil) then
			XUI_FlexTotalGroups = XUI_RetrieveOption(261)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(264) ~= nil) then
			if (XUI_RetrieveOption(264)[XUI_VALUE] == XUI_FlexToggleIcon) then
				XUI_FlexToggleIcon = XUI_RetrieveOption(264)[XUI_VALUE];
			else
				XUI_FlexToggleIcon = XUI_RetrieveOption(264)[XUI_VALUE];
				XUI_FlexTIcon();
			end			
		end
		if (XUI_RetrieveOption(265) ~= nil) then
			XUI_FlexButtonGap = XUI_RetrieveOption(265)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(266) ~= nil) then
			if (XUI_RetrieveOption(266)[XUI_VALUE] == XUI_FlexToggleText) then
				--do nothing
			else
				XUI_FlexToggleText = XUI_RetrieveOption(266)[XUI_VALUE];
				XUI_FlexToggleKey=0;
				XUI_FlexToggleCool=0;
				XUI_UpdateValue(268, 0);
				XUI_UpdateValue(269, 0);
				XUI_Option268:SetChecked(0);
				XUI_Option269:SetChecked(0);
				XUI_FlexTText();
			end	
		end
		if (XUI_RetrieveOption(268) ~= nil) then
			if (XUI_RetrieveOption(268)[XUI_VALUE] == XUI_FlexToggleKey) then
				--do nothing
			else
				XUI_FlexToggleKey = XUI_RetrieveOption(268)[XUI_VALUE];
				XUI_FlexToggleText=0;
				XUI_FlexToggleCool=0;
				XUI_UpdateValue(266, 0);
				XUI_UpdateValue(269, 0);
				XUI_Option266:SetChecked(0);
				XUI_Option269:SetChecked(0);
				XUI_FlexTText();
			end	
		end
		if (XUI_RetrieveOption(269) ~= nil) then
			if (XUI_RetrieveOption(269)[XUI_VALUE] == XUI_FlexToggleCool) then
				--do nothing
			else
				XUI_FlexToggleCool = XUI_RetrieveOption(269)[XUI_VALUE];
				XUI_FlexToggleText=0;
				XUI_FlexToggleKey=0;
				XUI_UpdateValue(266, 0);
				XUI_UpdateValue(268, 0);
				XUI_Option266:SetChecked(0);
				XUI_Option268:SetChecked(0);
				XUI_FlexTText();
			end	
		end
		if (XUI_RetrieveOption(270) ~= nil) then
			if (XUI_RetrieveOption(270)[XUI_VALUE] == XUI_FlexToggleVerbose) then
				XUI_FlexToggleVerbose = XUI_RetrieveOption(270)[XUI_VALUE];
			else
				XUI_FlexToggleVerbose = XUI_RetrieveOption(270)[XUI_VALUE];
				XUI_FlexTVerbose();
			end	
		end
		if (XUI_RetrieveOption(271) ~= nil) then
			if (XUI_RetrieveOption(271)[XUI_VALUE] == XUI_FlexToggleToolTip) then
				XUI_FlexToggleToolTip = XUI_RetrieveOption(271)[XUI_VALUE];
			else
				XUI_FlexToggleToolTip = XUI_RetrieveOption(271)[XUI_VALUE];
				XUI_FlexTToolTip();
			end	
		end
		if (XUI_RetrieveOption(301) ~= nil) then
			XUI_FlexWidth1 = XUI_RetrieveOption(301)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(302) ~= nil) then
			XUI_FlexHeight1 = XUI_RetrieveOption(302)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(303) ~= nil) then
			XUI_FlexScale1 = XUI_RetrieveOption(303)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(304) ~= nil) then
			XUI_FlexWidth2 = XUI_RetrieveOption(304)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(305) ~= nil) then
			XUI_FlexHeight2 = XUI_RetrieveOption(305)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(306) ~= nil) then
			XUI_FlexScale2 = XUI_RetrieveOption(306)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(307) ~= nil) then
			XUI_FlexWidth3 = XUI_RetrieveOption(307)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(308) ~= nil) then
			XUI_FlexHeight3 = XUI_RetrieveOption(308)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(309) ~= nil) then
			XUI_FlexScale3 = XUI_RetrieveOption(309)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(310) ~= nil) then
			XUI_FlexWidth4 = XUI_RetrieveOption(310)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(311) ~= nil) then
			XUI_FlexHeight4 = XUI_RetrieveOption(311)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(312) ~= nil) then
			XUI_FlexScale4 = XUI_RetrieveOption(312)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(313) ~= nil) then
			XUI_FlexWidth5 = XUI_RetrieveOption(313)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(314) ~= nil) then
			XUI_FlexHeight5 = XUI_RetrieveOption(314)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(315) ~= nil) then
			XUI_FlexScale5 = XUI_RetrieveOption(315)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(316) ~= nil) then
			XUI_FlexWidth6 = XUI_RetrieveOption(316)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(317) ~= nil) then
			XUI_FlexHeight6 = XUI_RetrieveOption(317)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(318) ~= nil) then
			XUI_FlexScale6 = XUI_RetrieveOption(318)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(319) ~= nil) then
			XUI_FlexWidth7 = XUI_RetrieveOption(319)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(320) ~= nil) then
			XUI_FlexHeight7 = XUI_RetrieveOption(320)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(321) ~= nil) then
			XUI_FlexScale7 = XUI_RetrieveOption(321)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(322) ~= nil) then
			XUI_FlexWidth8 = XUI_RetrieveOption(322)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(323) ~= nil) then
			XUI_FlexHeight8 = XUI_RetrieveOption(323)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(324) ~= nil) then
			XUI_FlexScale8 = XUI_RetrieveOption(324)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(325) ~= nil) then
			XUI_FlexPos1 = XUI_RetrieveOption(325)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(326) ~= nil) then
			XUI_FlexPos2 = XUI_RetrieveOption(326)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(327) ~= nil) then
			XUI_FlexPos3 = XUI_RetrieveOption(327)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(328) ~= nil) then
			XUI_FlexPos4 = XUI_RetrieveOption(328)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(329) ~= nil) then
			XUI_FlexPos5 = XUI_RetrieveOption(329)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(330) ~= nil) then
			XUI_FlexPos6 = XUI_RetrieveOption(330)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(331) ~= nil) then
			XUI_FlexPos7 = XUI_RetrieveOption(331)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(332) ~= nil) then
			XUI_FlexPos8 = XUI_RetrieveOption(332)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(333) ~= nil) then
			XUI_FlexAnchor1 = XUI_RetrieveOption(333)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(334) ~= nil) then
			XUI_FlexAnchor2 = XUI_RetrieveOption(334)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(335) ~= nil) then
			XUI_FlexAnchor3 = XUI_RetrieveOption(335)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(336) ~= nil) then
			XUI_FlexAnchor4 = XUI_RetrieveOption(336)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(337) ~= nil) then
			XUI_FlexAnchor5 = XUI_RetrieveOption(337)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(338) ~= nil) then
			XUI_FlexAnchor6 = XUI_RetrieveOption(338)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(339) ~= nil) then
			XUI_FlexAnchor7 = XUI_RetrieveOption(339)[XUI_VALUE];
		end
		if (XUI_RetrieveOption(340) ~= nil) then
			XUI_FlexAnchor8 = XUI_RetrieveOption(340)[XUI_VALUE];
		end
	end
end
