--[[
	XUI_Buttons.lua
	XUIVersion++2004.11.08++
	
	Options menu and lock all button functions.
]]
-- ** XUI BUTTON FUNCTIONS ** --
-- Tooltip display OnEnter
function XUI_ButtonOnEnter ()
	-- Set options menu tooltip
	GameTooltip:SetOwner(this, "ANCHOR_LEFT");
	GameTooltip:SetText("Open XUI options menu.", 1.0, 1.0, 1.0);
	-- Get options menu key binding and append it
	local keyBinding = GetBindingKey("XUIOPTIONSMENU");
	if (keyBinding) then
		GameTooltip:AppendText(" "..NORMAL_FONT_COLOR_CODE.."("..keyBinding..")"..FONT_COLOR_CODE_CLOSE);
	end
end
-- Function to hide or show our options frame, simply determine which by it's current state
function XUI_OptionsFrameToggle ()
	if (XUI_OptionsFrame:IsVisible()) then
		HideUIPanel(XUI_OptionsFrame);
		PlaySound("igMainMenuOption");
	else
		ShowUIPanel(XUI_OptionsFrame);
		PlaySound("igMainMenuQuit");
	end
end
